! -------------------------------------------------------------
! Two examination papers are written at the end of the course.
! The final mark is either the average of the two papers, or
! the average of the two papers and the class record mark (all
! weighted equally), whichever is the higher.  The program 
! should reads in the class record mark and the marks of the
! papers, computes the average, and shows PASS (>= 50%) or
! FAIL (< 50%).
! -------------------------------------------------------------

PROGRAM  FinalMark
   IMPLICIT  NONE

   REAL    :: Mark1, Mark2         ! the marks of the papers
   REAL    :: Final                ! the final marks
   REAL    :: ClassRecordMark      ! the class record mark
   
   REAL, PARAMETER :: PassLevel = 50.0  ! the pass level

   READ(*,*)  ClassRecordMark, Mark1, Mark2
   
   Final = (Mark1 + Mark2) / 2.0
   IF (Final <= ClassRecordMark) THEN
      Final = (Mark1 + Mark2 + ClassRecordMark) / 3.0
   END IF

   WRITE(*,*)  'Class Record Mark : ', ClassRecordMark
   WRITE(*,*)  'Mark 1            : ', Mark1
   WRITE(*,*)  'Mark 2            : ', Mark2
   WRITE(*,*)  'Final Mark        : ', Final

   IF (Final >= PassLevel) THEN
      WRITE(*,*)  'Pass Status       : PASS'
   ELSE
      WRITE(*,*)  'Pass Status       : FAIL'
   END IF

END PROGRAM  FinalMark

! --------------------------------------------------------------------
! PROGRAM  ComputeFactorial:
!    This program uses MODULE FactorialModule for computing factorial
! and combinatorial coefficients.
! --------------------------------------------------------------------

PROGRAM  ComputeFactorial
   USE       FactorialModule            ! use a module

   IMPLICIT  NONE

   INTEGER :: N, R                     

   WRITE(*,*)  'Two non-negative integers --> '
   READ(*,*)   N, R

   WRITE(*,*)  N,   '! = ', Factorial(N)
   WRITE(*,*)  R,   '! = ', Factorial(R)

   IF (R <= N) THEN                     ! if r <= n, do C(n,r)
      WRITE(*,*)  'C(', N, ',', R, ') = ', Combinatorial(N, R)
   ELSE                                 ! otherwise, do C(r,n)
      WRITE(*,*)  'C(', R, ',', N, ') = ', Combinatorial(R, N)
   END IF

END PROGRAM  ComputeFactorial

! --------------------------------------------------------------------
! PROGRAM  ComputeMedian:
!	This program contains an internal REAL function for computing the
! median of a set of input.  The median of a set of N data values is
! defined as follows.  First, the data values must be sorted.  Then,
! the median is the middle value X(N/2+1) if N is odd; otherwise, the
! median is the average of the middle two values (i.e., (X(n)+X(N/2+1))/2).
! For example, the median of 4, 2, 3, 1 is 2.5 since the sorted data
! values are 1, 2, 3 and 4 and the average of the middle two data
! values is (2+3)/2.  The median of 5, 3, 4, 1, 2 is 3 since 3 is the
! middle value of the sorted data 1, 2, 3, 4, 5.
!
! We shall use the sorting subroutine discussed earlier.
! --------------------------------------------------------------------

PROGRAM  ComputeMedian
   USE       Sorting
   IMPLICIT  NONE
   INTEGER, PARAMETER               :: ARRAY_SIZE = 20
   INTEGER, DIMENSION(1:ARRAY_SIZE) :: DataArray
   INTEGER                          :: ActualSize
   INTEGER                          :: IOstatus
   INTEGER                          :: i

   DO
      READ(*,*,IOSTAT=IOstatus) ActualSize, (DataArray(i), i = 1, ActualSize)
      IF (IOstatus < 0) THEN
         WRITE(*,*)  "End of data reached."
         EXIT
      ELSE IF (IOstatus > 0) THEN
         WRITE(*,*)  "Something wrong in your data."
         EXIT
      ELSE
         WRITE(*,*)  "InputData:"
         WRITE(*,*)  (DataArray(i), i = 1, ActualSize)
         WRITE(*,*)
         WRITE(*,*)  "Median = ", Median(DataArray, ActualSize)
         WRITE(*,*)
      END IF
   END DO

CONTAINS

! --------------------------------------------------------------------
! REAL FUNCTION  Median() :
!    This function receives an array X of N entries, copies its value
! to a local array Temp(), sorts Temp() and computes the median.
!    The returned value is of REAL type.
! --------------------------------------------------------------------

   REAL FUNCTION  Median(X, N)
      IMPLICIT  NONE
      INTEGER, DIMENSION(1:), INTENT(IN) :: X
      INTEGER, INTENT(IN)                :: N
      INTEGER, DIMENSION(1:N)            :: Temp
      INTEGER                            :: i

      DO i = 1, N                       ! make a copy
         Temp(i) = X(i)
      END DO
      CALL  Sort(Temp, N)               ! sort the copy
      IF (MOD(N,2) == 0) THEN           ! compute the median
         Median = (Temp(N/2) + Temp(N/2+1)) / 2.0
      ELSE
         Median = Temp(N/2+1)
      END IF
   END FUNCTION  Median

END PROGRAM  ComputeMedian

! --------------------------------------------------------------------
! MODULE  FactorialModule
!    This module contains two procedures: Factorial(n) and 
! Combinatorial(n,r).  The first computes the factorial of an integer 
! n and the second computes the combinatorial coefficient of two 
! integers n and r.
! --------------------------------------------------------------------

MODULE  FactorialModule
   IMPLICIT  NONE

CONTAINS

! --------------------------------------------------------------------
! FUNCTION  Factorial() :
!    This function accepts a non-negative integers and returns its
! Factorial.
! --------------------------------------------------------------------
  
   INTEGER FUNCTION  Factorial(n)
      IMPLICIT  NONE

      INTEGER, INTENT(IN) :: n          ! the argument
      INTEGER             :: Fact, i    ! result

      Fact = 1                          ! initially, n!=1
      DO i = 1, n                       ! this loop multiplies
         Fact = Fact * i                ! i to n!
      END DO
      Factorial = Fact                  

   END FUNCTION  Factorial

! --------------------------------------------------------------------
! FUNCTION  Combinarotial():
!    This function computes the combinatorial coefficient C(n,r).
! If 0 <= r <= n, this function returns C(n,r), which is computed as
! C(n,r) = n!/(r!*(n-r)!).  Otherwise, it returns 0, indicating an
! error has occurred.
! --------------------------------------------------------------------

   INTEGER FUNCTION  Combinatorial(n, r)
      IMPLICIT  NONE

      INTEGER, INTENT(IN) :: n, r
      INTEGER             :: Cnr

      IF (0 <= r .AND. r <= n) THEN     ! valid arguments ?
         Cnr = Factorial(n) / (Factorial(r)*Factorial(n-r))
      ELSE                              ! no,
         Cnr = 0                        ! zero is returned
      END IF
      Combinatorial = Cnr

   END FUNCTION  Combinatorial

END MODULE  FactorialModule

! ---------------------------------------------------------------
! This program finds all prime numbers in the range of 2 and an
! input integer.
! ---------------------------------------------------------------

PROGRAM  Primes
   IMPLICIT  NONE
   
   INTEGER  :: Range, Number, Divisor, Count

   WRITE(*,*)  'What is the range ? '
   DO                                   ! keep trying to read a good input
      READ(*,*)  Range                  ! ask for an input integer
      IF (Range >= 2)  EXIT             ! if it is GOOD, exit
      WRITE(*,*)  'The range value must be >= 2.  Your input = ', Range
      WRITE(*,*)  'Please try again:'   ! otherwise, bug the user
   END DO
   
   Count = 1                            ! input is correct. start counting
   WRITE(*,*)                           ! since 2 is a prime
   WRITE(*,*)  'Prime number #', Count, ': ', 2
   DO Number = 3, Range, 2              ! try all odd numbers 3, 5, 7, ...

      Divisor = 3                       ! divisor starts with 3
      DO
         IF (Divisor*Divisor > Number .OR. MOD(Number,Divisor) == 0)  EXIT
         Divisor = Divisor + 2          ! if does not evenly divide, next odd
      END DO

      IF (Divisor*Divisor > Number) THEN     ! are all divisor exhausted?
         Count = Count + 1              ! yes, this Number is a prime
         WRITE(*,*)  'Prime number #', Count, ': ', Number
      END IF
   END DO
   
   WRITE(*,*)
   WRITE(*,*)  'There are ', Count, ' primes in the range of 2 and ', Range
   
END PROGRAM  Primes
      

PROGRAM  Mean
   IMPLICIT  NONE
   INTEGER, PARAMETER         :: SIZE = 20
   REAL, DIMENSION(1:SIZE)    :: x
   INTEGER                    :: ActualSize
   INTEGER                    :: i
   REAL                       :: Average
   CHARACTER(LEN=30)          :: Title = "(A, A)"

   READ(*,*)  ActualSize
   READ(*,*)  (x(i), i = 1, ActualSize)

   Average = 0.0
   DO i = 1, ActualSize
      Average = Average + x(i)
   END DO
   Average = Average / ActualSize

   WRITE(*,Title)  " ", "Average Computation"
   WRITE(*,Title)  " "
   WRITE(*,Title)  " ", "Input Data"
   WRITE(*,Title)  " "
   WRITE(*,"(5F10.2)")  (x(i), i = 1, ActualSize)
   WRITE(*,Title)  " "
   WRITE(*,"(A, A,ES15.7)")  " ", "Average = ", Average
END PROGRAM  Mean

PROGRAM  InnerProduct
   IMPLICIT  NONE
   INTEGER, PARAMETER         :: SIZE = 50
   INTEGER                    :: Number, Sum, i
   INTEGER, DIMENSION(1:SIZE) :: x, y
   CHARACTER(LEN=80)          :: Fmt1, Fmt2, Fmt3

   Fmt1 = "(I5/(2I5))"
   Fmt2 = "(1X,A//1X,3A5/(1X,3I5))"
   Fmt3 = "(/1X, A, I7)"

   READ(*,Fmt1)   Number, (x(i), y(i), i = 1, Number)
   WRITE(*,Fmt2)  "Input Data", "No", "X", "Y", &
                  (i, x(i), y(i), i = 1, Number)
   Sum = 0
   DO i = 1, Number
      Sum = Sum + x(i)*y(i)
   END DO
   WRITE(*,Fmt3)  "Input product = ", Sum
END PROGRAM  InnerProduct

! --------------------------------------------------------------------
! PROGRAM  TableLookUp
!    Given an array and a input value, this program can determine if 
! the value if in the table.  If it is, the array location where the 
! value is stored is returned.  Binary search is used.
! --------------------------------------------------------------------

PROGRAM  TableLookUp
   IMPLICIT  NONE
   INTEGER, PARAMETER              :: TableSize = 100
   INTEGER, DIMENSION(1:TableSize) :: Table
   INTEGER                         :: ActualSize
   INTEGER                         :: Key
   INTEGER                         :: Location
   INTEGER                         :: i
   INTEGER                         :: end_of_input

   READ(*,*)  ActualSize                ! read in the actual size and table
   READ(*,*)  (Table(i), i = 1, ActualSize)
   WRITE(*,*) "Input Table:"
   WRITE(*,*) (Table(i), i = 1, ActualSize)
   WRITE(*,*)
   DO                                   ! keep reading in a key value
      WRITE(*,*)  "A search key please --> "
      READ(*,*,IOSTAT=end_of_input)  Key
      IF (end_of_input < 0)  EXIT       ! EXIT of end-of-file reached
      Location = LookUp(Table, ActualSize, Key)   ! do a table look up
      IF (Location > 0) THEN            ! display the search result
         WRITE(*,*)  "Key value ", Key, " appears in location ", Location
      ELSE
         WRITE(*,*)  "Key value ", Key, " is not found"
      END IF
   END DO
   WRITE(*,*)
   WRITE(*,*) "Table lookup operation completes"

CONTAINS

! --------------------------------------------------------------------
! INTEGER FUNCTION  LookUp():
!    Given an array x() and a key value Data, this function determines
! if Data is a member of x().  If it is, the index where Data can be 
! found is returned; otherwise, it returns 0.
! --------------------------------------------------------------------

   INTEGER FUNCTION  LookUp(x, Size, Data)
      IMPLICIT  NONE
      INTEGER, DIMENSION(1:), INTENT(IN) :: x
      INTEGER, INTENT(IN)                :: Size
      INTEGER, INTENT(IN)                :: Data
      INTEGER                            :: Left, Right, Mid

      LookUp = 0                        ! assume not found
      Left  = 1 			! left end
      Right = Size			! right end
      DO				! loop until done
         IF (Left > Right)  EXIT	! if left and right cross, exit
         Mid = (Left + Right) / 2	! get the midpoint
         IF (Data == x(Mid)) THEN	! is input = to the midpoint
            LookUp = Mid		! Yes, record the position
            EXIT			! and exit
         ELSE IF (Data < x(Mid)) THEN	! is Data < midpoint?
            Right = Mid - 1		! YES, ignore the right half
         ELSE
            Left  = Mid + 1		! otherwise, ignore the left half
         END IF
      END DO				! go back and try again
   END FUNCTION  LookUp

END PROGRAM  TableLookUp

! -------------------------------------------------------
! This program reads in three INTEGERs and displays them 
! in ascending order.
! -------------------------------------------------------
 
PROGRAM  Order
   IMPLICIT  NONE
 
   INTEGER  :: a, b, c

   READ(*,*)  a, b, c

   IF (a < b) THEN                 ! a < b here
      IF (a < c) THEN              !   a < c     : a the smallest
         IF (b < c) THEN           !      b < c  : a < b < c
            WRITE(*,*)  a, b, c
         ELSE                      !      c <= b : a < c <= b
            WRITE(*,*)  a, c, b
         END IF
      ELSE                         !   a >= c    : c <= a < b
         WRITE(*,*) c, a, b
      END IF
   ELSE                            ! b <= a here
      IF (b < c) THEN              !   b < c     : b the smallest
         IF (a < c) THEN           !     a < c   : b <= a < c 
            WRITE(*,*)  b, a, c
         ELSE                      !     a >= c  : b < c <= a
            WRITE(*,*)  b, c, a
         END IF
      ELSE                         !   c <= b    : c <= b <= a
         WRITE(*,*)  c, b, a
      END IF
   END IF

END PROGRAM  Order

! ---------------------------------------------------
!   Solve  Ax^2 + Bx + C = 0 given B*B-4*A*C >= 0   
!   Now, we are able to detect the following:
!    (1) unsolvable equation
!    (2) linear equation
!    (3) quadratic equation
!        (a) distinct real roots
!        (b) repeated root
!        (c) no real roots
! ---------------------------------------------------
 
PROGRAM  QuadraticEquation
   IMPLICIT  NONE

   REAL  :: a, b, c
   REAL  :: d
   REAL  :: root1, root2
   
!  read in the coefficients a, b and c

   READ(*,*)  a, b, c
   WRITE(*,*) 'a = ', a
   WRITE(*,*) 'b = ', b
   WRITE(*,*) 'c = ', c
   WRITE(*,*)

   IF (a == 0.0) THEN              ! could be a linear equation
      IF (b == 0.0) THEN           ! the input becomes c = 0
         IF (c == 0.0) THEN        ! all numbers are roots
            WRITE(*,*)  'All numbers are roots'
         ELSE                      ! unsolvable
            WRITE(*,*)  'Unsolvable equation'
         END IF
      ELSE                         ! linear equation
         WRITE(*,*)  'This is linear equation, root = ', -c/b
      END IF
   ELSE                            ! ok, we have a quadratic equation
      d = b*b - 4.0*a*c
      IF (d > 0.0) THEN            ! distinct roots?
         d     = SQRT(d)
         root1 = (-b + d)/(2.0*a)  ! first root
         root2 = (-b - d)/(2.0*a)  ! second root
         WRITE(*,*)  'Roots are ', root1, ' and ', root2
      ELSE IF (d == 0.0) THEN      ! repeated roots?
         WRITE(*,*)  'The repeated root is ', -b/(2.0*a)
      ELSE                         ! complex roots
         WRITE(*,*)  'There is no real roots!'
         WRITE(*,*)  'Discriminant = ', d
      END IF
   END IF

END PROGRAM  QuadraticEquation

! ---------------------------------------------------------
! This program computes the GCD of two positive integers
! using the Euclid method.  Given a and b, a >= b, the 
! Euclid method goes as follows:  (1) dividing a by b yields 
! a reminder c; (2) if c is zero, b is the GCD; (3) if c is
! no zero, b becomes a and c becomes c and go back to
! Step (1).  This process will continue until c is zero.
! ---------------------------------------------------------

PROGRAM  GreatestCommonDivisor
   IMPLICIT  NONE

   INTEGER   :: a, b, c

   WRITE(*,*) 'Two positive integers please --> '
   READ(*,*)  a, b
   IF (a < b) THEN       ! since a >= b must be true, they
      c = a              ! are swapped if a < b
      a = b
      b = c
   END IF

   DO                    ! now we have a <= b
      c = MOD(a, b)      !    compute c, the reminder
      IF (c == 0) EXIT   !    if c is zero, we are done.  GCD = b
      a = b              !    otherwise, b becomes a
      b = c              !    and c becomes b
   END DO                !    go back

   WRITE(*,*) 'The GCD is ', b  

END PROGRAM  GreatestCommonDivisor

      PROGRAM  MuxTest
        IMPLICIT  NONE

!        INTEGER(4), PARAMETER :: TERM_ADDR = 28
!        INTEGER(4), PARAMETER :: SEND_RECV = 1
!        INTEGER(4), PARAMETER :: TSUB_ADDR = 16
!        INTEGER(4), PARAMETER :: WORD_CT   = 20
!        INTEGER(4), PARAMETER :: RT_UP     = 31

!        CALL SomeRoutine(TERM_ADDR, SEND_RECV, TSUB_ADDR, WORD_CT, RT_UP)
!        CALL SomeRoutine(28, 1, 16, 20, 31)
#include "mux_test_3.H"
        CALL MACRO_SR
!        call macro_sr

     END PROGRAM  MuxTest

! ---------------------------------------------------------------
! This program computes the combinatorial coefficient C(n,r):
!
!                       n!
!         C(n,r) = -------------
!                   r! x (n-r)!
!
! It asks for two integers and uses Cnr(n,r) to compute the value.
! If 0 <= r <= n does not hold, Cnr() returns -1 so that the main
! program would know the input values are incorrect.  Otherwise,
! Cnr() returns the desired combinatorial coefficient.
!
! Note that if the input values are zeros, this program stops.
! ---------------------------------------------------------------

PROGRAM  Combinatorial
   IMPLICIT   NONE

   INTEGER :: n, r, Answer

   DO
      WRITE(*,*)
      WRITE(*,*)  "Two integers n and r (0 <= r <= n) please "
      WRITE(*,*)  "0 0 to stop --> "
      READ(*,*)   n, r
      IF (n == 0 .AND. r == 0)  EXIT
      WRITE(*,*)  "Your input:"
      WRITE(*,*)  "  n      = ", n
      WRITE(*,*)  "  r      = ", r
      Answer = Cnr(n, r)
      IF (Answer < 0) THEN
         WRITE(*,*)  "Incorrect input"
      ELSE
         WRITE(*,*) "  C(n,r) = ", Answer
      END IF
   END DO

CONTAINS

! ---------------------------------------------------------------
! INTEGER FUNCTION  Cnr(n,r)
!    This function receives n and r, uses LOGICAL function Test()
! to verify if the condition 0 <= r <= n holds, and uses
! Factorial() to compute n!, r! and (n-r)!.
! ---------------------------------------------------------------

   INTEGER FUNCTION  Cnr(n, r)
      IMPLICIT  NONE
      INTEGER, INTENT(IN) :: n, r

      IF (Test(n,r)) THEN
         Cnr = Factorial(n)/(Factorial(r)*Factorial(n-r))
      ELSE
         Cnr = -1
      END IF
   END FUNCTION  Cnr

! ---------------------------------------------------------------
! LOGICAL FUNCTION  Test()
!    This function receives n and r.  If 0 <= r <= n holds, it
! returns .TRUE.; otherwise, it returns .FALSE.
! ---------------------------------------------------------------

   LOGICAL FUNCTION  Test(n, r)
      IMPLICIT  NONE
      INTEGER, INTENT(IN) :: n, r

      Test = (0 <= r) .AND. (r <= n)
   END FUNCTION  Test

! ---------------------------------------------------------------
! INTEGER FUNCTION  Factorial()
!    This function receives a non-negative integer and computes
! its factorial.
! ---------------------------------------------------------------

   INTEGER FUNCTION  Factorial(k)
      IMPLICIT  NONE
      INTEGER, INTENT(IN) :: k
      INTEGER             :: Ans, i

      Ans = 1
      DO i = 1, k
         Ans = Ans * i
      END DO
      Factorial = Ans
   END FUNCTION  Factorial

END PROGRAM  Combinatorial

PROGRAM  Single_Column
   IMPLICIT  NONE
   INTEGER, PARAMETER             :: MAX_SIZE = 20
   INTEGER, DIMENSION(1:MAX_SIZE) :: x
   INTEGER                        :: i
   CHARACTER(LEN=80)              :: FMT

   DO i = 1, MAX_SIZE
      X(i) = MOD(i, 5) + i
   END DO

   FMT = "(T7, A/ T7, A// T10, A, T15, A/(T10, I2, T15, I4))"
   WRITE(*,FMT)  'Generated Table',   &
                 '---------------',   &
                 'No', 'Data',        &
                 (x(i), i = 1, MAX_SIZE)

END PROGRAM  Single_Column

! ---------------------------------------------------------------
! PROGRAM  Reverse:
!    This program reverses the order of an input array.
! ---------------------------------------------------------------

PROGRAM  Reverse
   IMPLICIT  NONE

   INTEGER, PARAMETER :: SIZE = 30      ! maximum array size
   INTEGER, DIMENSION(1:SIZE) :: a      ! input array
   INTEGER            :: n              ! actual input array size
   INTEGER            :: Head           ! pointer moving forward
   INTEGER            :: Tail           ! pointer moving backward
   INTEGER            :: Temp, i

   READ(*,*)  n                         ! read in the input array
   READ(*,*)  (a(i), i = 1, n)
   WRITE(*,*) "Input array:"            ! display the input array
   WRITE(*,*) (a(i), i = 1, n)

   Head = 1                             ! start with the beginning
   Tail = n                             ! start with the end
   DO                                   ! for each pair...
      IF (Head >= Tail)  EXIT           !    if Head crosses Tail, exit
      Temp    = a(Head)                 !    otherwise, swap them
      a(Head) = a(Tail)
      a(Tail) = Temp
      Head    = Head + 1                !    move forward
      Tail    = Tail - 1                !    move backward
   END DO                               ! loop back

   WRITE(*,*)                           ! display the result
   WRITE(*,*)  "Reversed array:"
   WRITE(*,*)  (a(i), i = 1, n)

END PROGRAM  Reverse

PROGRAM  LogFunction
   IMPLICIT   NONE
   REAL, PARAMETER   :: Initial =  2.0
   REAL, PARAMETER   :: Final   =  0.0
   REAL, PARAMETER   :: Step    = -0.2
   REAL              :: x
   INTEGER           :: Count
   CHARACTER(LEN=80) :: FMT

   FMT   = "(I3, F10.5, E15.5, E15.5E3, ES15.5, EN15.5)"
   Count = 1
   x     = Initial
   DO
      IF (x <= Final)  EXIT
      WRITE(*,FMT)     Count, x, LOG(x), LOG(x), LOG(x), LOG(x)
      x     = x + Step
      Count = Count + 1
   END DO
END PROGRAM  LogFunction

! --------------------------------------------------------------------
! PROGRAM  MovingAverage:
!    This program reads in a set of input values and a window value,
! and computes the moving average of the input.  Let the values be
! x1, x2, x3, ..., xn and the window value is k.
! --------------------------------------------------------------------

PROGRAM  MovingAverage
   IMPLICIT  NONE
  
   INTEGER, PARAMETER :: MAX_SIZE = 30       ! array size
   REAL, DIMENSION(1:MAX_SIZE) :: x, Avg     ! arrays
   REAL               :: Sum                 ! for computation use
   INTEGER            :: Window              ! window size
   INTEGER            :: Size                ! actual array size
   INTEGER            :: i, j                ! indices

   READ(*,*)  Size, (x(i), i = 1, Size)      ! read in input data
   READ(*,*)  Window                         ! read in window value
   
   WRITE(*,*) "**********************************"     ! display input
   WRITE(*,*) "*   Moving Average Computation   *"
   WRITE(*,*) "**********************************"
   WRITE(*,*)
   WRITE(*,*) "Input Array:"
   WRITE(*,*) (x(i), i = 1, Size)
   WRITE(*,*)
   WRITE(*,*) "Window Size = ", Window

   DO i = 1, Size-Window+1                   ! for each xi
      Sum = 0.0                              ! compute the moving average
      DO j = i, i+Window-1                   ! of xi, x(i+1), ..., 
         Sum = Sum + x(j)                    ! x(i+Window-1).
      END DO
      Avg(i) = Sum / Window                  ! save the result
   END DO

   WRITE(*,*)                                ! display the result
   WRITE(*,*)  "Moving Average of the Given Array:"
   WRITE(*,*)  (Avg(i), i = 1, Size-Window+1)
END PROGRAM  MovingAverage

PROGRAM  Squares_and_Roots
   IMPLICIT  NONE
   INTEGER, PARAMETER :: MAXIMUM = 10
   INTEGER            :: i
   CHARACTER(LEN=30)  :: Format
   
   Format = "(3I6, 2F12.7)"
   DO i = 1, MAXIMUM
      WRITE(*,Format)  i, i*i, i*i*i, SQRT(REAL(i)), SQRT(SQRT(REAL(i)))
   END DO
END PROGRAM  Squares_and_Roots

! --------------------------------------------------------------------
! MODULE  MyTrigonometricFunctions:
!    This module provides the following functions and constants
!    (1) RadianToDegree()     - converts its argument in radian to
!                               degree
!    (2) DegreeToRadian()     - converts its argument in degree to
!                               radian
!    (3) MySIN()              - compute the sine of its argument in
!                               degree
!    (4) MyCOS()              - compute the cosine of its argument
!                               in degree
! --------------------------------------------------------------------

MODULE  MyTrigonometricFunctions
   IMPLICIT   NONE

   REAL, PARAMETER :: PI        = 3.1415926       ! some constants
   REAL, PARAMETER :: Degree180 = 180.0
   REAL, PARAMETER :: R_to_D    = Degree180/PI
   REAL, PARAMETER :: D_to_R    = PI/Degree180

CONTAINS

! --------------------------------------------------------------------
! FUNCTION  RadianToDegree():
!    This function takes a REAL argument in radian and converts it to
! the equivalent degree.
! --------------------------------------------------------------------

   REAL FUNCTION  RadianToDegree(Radian)
      IMPLICIT  NONE
      REAL, INTENT(IN) :: Radian

      RadianToDegree = Radian * R_to_D
   END FUNCTION  RadianToDegree

! --------------------------------------------------------------------
! FUNCTION  DegreeToRadian():
!    This function takes a REAL argument in degree and converts it to
! the equivalent radian.
! --------------------------------------------------------------------

   REAL FUNCTION  DegreeToRadian(Degree)
      IMPLICIT  NONE
      REAL, INTENT(IN) :: Degree

      DegreeToRadian = Degree * D_to_R
   END FUNCTION  DegreeToRadian

! --------------------------------------------------------------------
! FUNCTION  MySIN():
!    This function takes a REAL argument in degree and computes its
! sine value.  It does the computation by converting its argument to
! radian and uses Fortran's sin().
! --------------------------------------------------------------------

   REAL FUNCTION  MySIN(x)
      IMPLICIT  NONE
      REAL, INTENT(IN) :: x

      MySIN = SIN(DegreeToRadian(x))
   END FUNCTION  MySIN

! --------------------------------------------------------------------
! FUNCTION  MySIN():
!    This function takes a REAL argument in degree and computes its
! cosine value.  It does the computation by converting its argument to
! radian and uses Fortran's cos().
! --------------------------------------------------------------------

   REAL FUNCTION  MyCOS(x)
      IMPLICIT  NONE
      REAL, INTENT(IN) :: x

      MyCOS = COS(DegreeToRadian(x))
   END FUNCTION  MyCOS

END MODULE  MyTrigonometricFunctions

! -------------------------------------------------------
!   Computes arithmetic, geometric and harmonic means   
! -------------------------------------------------------

PROGRAM  ComputeMeans
   IMPLICIT  NONE

   REAL  :: X = 1.0, Y = 2.0, Z = 3.0
   REAL  :: ArithMean, GeoMean, HarmMean

   WRITE(*,*)  'Data items: ', X, Y, Z
   WRITE(*,*)
   
   ArithMean = (X + Y + Z)/3.0
   GeoMean   = (X * Y * Z)**(1.0/3.0)
   HarmMean  = 3.0/(1.0/X + 1.0/Y + 1.0/Z)
   
   WRITE(*,*)  'Arithmetic mean = ', ArithMean
   WRITE(*,*)  'Geometric mean  = ', GeoMean
   WRITE(*,*)  'Harmonic Mean   = ', HarmMean

END PROGRAM ComputeMeans

! ----------------------------------------------------------
!    This program contains three functions for computing the
! arithmetic, geometric and harmonic means of three REALs.
! ----------------------------------------------------------

PROGRAM  ComputingMeans
   IMPLICIT  NONE

   REAL  :: a, b, c

   READ(*,*)  a, b, c
   WRITE(*,*) 'Input: ', a, b, c
   WRITE(*,*)
   WRITE(*,*) 'Arithmetic mean = ', ArithMean(a, b, c)
   WRITE(*,*) 'Geometric mean  = ', GeoMean(a, b, c)
   WRITE(*,*) 'Harmonic mean   = ', HarmonMean(a, b, c)

CONTAINS

! ----------------------------------------------------------
! REAL FUNCTION  ArithMean() :
!    This function computes the arithmetic mean of its
! three REAL arguments.
! ----------------------------------------------------------

   REAL FUNCTION  ArithMean(a, b, c)
      IMPLICIT  NONE

      REAL, INTENT(IN) :: a, b, c

      ArithMean = (a + b + c) /3.0
   END FUNCTION  ArithMean

! ----------------------------------------------------------
! REAL FUNCTION  GeoMean() :
!    This function computes the geometric mean of its
! three REAL arguments.
! ----------------------------------------------------------

   REAL FUNCTION  GeoMean(a, b, c)
      IMPLICIT  NONE

      REAL, INTENT(IN) :: a, b, c

      GeoMean = (a * b * c)**(1.0/3.0)
   END FUNCTION  GeoMean

! ----------------------------------------------------------
! REAL FUNCTION  HarmonMean() :
!    This function computes the harmonic mean of its
! three REAL arguments.
! ----------------------------------------------------------

   REAL FUNCTION  HarmonMean(a, b, c)
      IMPLICIT  NONE

      REAL, INTENT(IN) :: a, b, c

      HarmonMean = 3.0 / (1.0/a + 1.0/b + 1.0/c)
   END FUNCTION  HarmonMean

END PROGRAM  ComputingMeans

PROGRAM  Test
   IMPLICIT NONE
   CHARACTER(LEN=40)         :: Buffer
   INTEGER, DIMENSION(1:100) :: X
   INTEGER :: i

   WRITE(Buffer,"(10I4)") (i, i = 1, 10)
   WRITE(*,*)  Buffer
   WRITE(*,*)
   READ(Buffer,"(BN,8I5)")   (X(i), i = 1, 8)
   WRITE(*,*)                (X(i), i = 1, 8)
   WRITE(*,*)
   READ(Buffer,"(BZ,8I5)")   (X(i), i = 1, 8)
   WRITE(*,*)                (X(i), i = 1, 8)
END PROGRAM Test

! --------------------------------------------------------------------
! PROGRAM  MeanVariance:
!    This program reads in an array and computes the mean, variance
! and standard deviation of the data stored in the array.  Then, it
! displays an analysis table.  If a value is greater than the value
! of (mean + standard deviation), it displays a "good".  If a value
! is less than the value of (mean - standard deviation), it displays
! a "bad".
! --------------------------------------------------------------------

PROGRAM  MeanVariance
   IMPLICIT  NONE

   INTEGER, PARAMETER :: MAX_SIZE = 50       ! maximum array size
   REAL, DIMENSION(1:MAX_SIZE) :: Data       ! input array
   REAL               :: Mean, Variance, StdDev   ! results
   INTEGER            :: n                   ! actual array size
   INTEGER            :: i                   ! running index
   CHARACTER(LEN=20)  :: For_Title    = '(A, A)'
   CHARACTER(LEN=20)  :: For_Data     = '(I4, F7.2)'
   CHARACTER(LEN=20)  :: For_Result   = '(A, A, F15.7)'
   CHARACTER(LEN=20)  :: For_Analysis = '(I4, 2F7.2, A)'

   READ(*,*)  n                              ! read in input array
   READ(*,*)  (Data(i), i = 1, n)
   WRITE(*,For_Title)  " ", " Input Data:"   ! display the input
   WRITE(*,*)
   WRITE(*,For_Title)  " ", "  No  Data"
   WRITE(*,For_Title)  " ", "=== ======"
   WRITE(*,For_Data)   (i, Data(i), i = 1, n)

   Mean = 0.0                                ! compute mean
   DO i = 1, n
      Mean = Mean + Data(i)
   END DO
   Mean = Mean / n

   Variance = 0.0                            ! compute variance
   DO i = 1, n
      Variance = Variance + (Data(i) - Mean)**2
   END DO
   Variance = Variance / (n - 1)
   StdDev   = SQRT(Variance)                 ! compute standard deviation

   WRITE(*,*)                                ! display result
   WRITE(*,For_Result) " ", "Mean               : ", Mean
   WRITE(*,For_Result) " ", "Variance           : ", Variance
   WRITE(*,For_Result) " ", "Standard Deviation : ", StdDev
   WRITE(*,*)
   WRITE(*,For_Title)  " ", "Analysis Table:"! display an analysis table
   WRITE(*,*)
   WRITE(*,For_Title)  " ", " No  Data    Dev "
   WRITE(*,For_Title)  " ", "=== ======  ====="
   DO i = 1, n
      IF (Data(i) > Mean + StdDev) THEN
         WRITE(*,For_Analysis)  i, Data(i), Data(i) - Mean, " <-- Good"
      ELSE IF (Data(i) < Mean - StdDev) THEN
         WRITE(*,For_Analysis)  i, Data(i), Data(i) - Mean, " <-- Bad"
      ELSE
         WRITE(*,For_Analysis)  i, Data(i), Data(i) - Mean
      END IF
   END DO

END PROGRAM  MeanVariance

PROGRAM  Select_Numbers
   IMPLICIT  NONE
   INTEGER           :: Number, i
   REAL              :: u, v, Sum
   CHARACTER(LEN=40) :: ReadIn, WriteOut, Title, Last

   Title    = "(1X,A)"
   ReadIn   = "(T11, F10.2, T41, F10.2)"
   WriteOut = "(1X, I4, A, 2F7.2)"
   Last     = "(1X, A, F7.2)"

   READ(*,"(I5)")  Number
   Sum = 0.0
   WRITE(*,Title)  "Input Number List"
   WRITE(*,Title)  "================="
   WRITE(*,*)
   DO i = 1, Number
      READ(*,ReadIn)  u, v
      WRITE(*,WriteOut)  i, " - ", u, v
      Sum = Sum + u*v
   END DO
   WRITE(*,Title)  "---------------------"
   WRITE(*,Last)   "Sum = ", Sum
END PROGRAM  Select_Numbers

! -----------------------------------------------------
!    This program display the cubes of INTEGERs and 
! REALs.  The cubes are computed with two functions:
! intCube() and realCube().
! -----------------------------------------------------

PROGRAM  Cubes
   IMPLICIT   NONE

   INTEGER, PARAMETER :: Iterations = 10
   INTEGER            :: i
   REAL               :: x

   DO i = 1, Iterations
      x = i
      WRITE(*,*)  i, x, intCube(i), realCube(x)
   END DO

CONTAINS

! -----------------------------------------------------
! INTEGER FUNCTION intCube() :
!    This function returns the cube of the argument.
! -----------------------------------------------------

   INTEGER  FUNCTION  intCube(Number)
      IMPLICIT   NONE

      INTEGER, INTENT(IN) :: Number

      intCube = Number*Number*Number
   END FUNCTION  intCube

! -----------------------------------------------------
! REAL FUNCTION realCube() :
!    This function returns the cube of the argument.
! -----------------------------------------------------

   REAL FUNCTION  realCube(Number)
      IMPLICIT  NONE

      REAL, INTENT(IN) :: Number

      realCube = Number*Number*Number
   END FUNCTION  realCube

END PROGRAM  Cubes

! -----------------------------------------------------------
! This program can read an unknown number of input until the
! end of file is reached.  It calculates the arithmetic,
! geometric, and harmonic means of these numbers.
!
! This program uses IOSTAT= to detect the following two
! conditions:
!    (1)  if the input contains illegal symbols (not numbers)
!    (2)  if the end of input has reached
! -----------------------------------------------------------

PROGRAM   ComputingMeans
   IMPLICIT  NONE

   REAL    :: X
   REAL    :: Sum, Product, InverseSum
   REAL    :: Arithmetic, Geometric, Harmonic
   INTEGER :: Count, TotalValid
   INTEGER :: IO                        ! this is new variable

   Sum        = 0.0
   Product    = 1.0
   InverseSum = 0.0
   TotalValid = 0
   Count      = 0

   DO
      READ(*,*,IOSTAT=IO)  X            ! read in data
      IF (IO < 0)  EXIT                 ! IO < 0 means end-of-file reached
      Count = Count + 1                 ! otherwise, there are data in input
      IF (IO > 0) THEN                  ! IO > 0 means something wrong
         WRITE(*,*)  'ERROR: something wrong in your input'
         WRITE(*,*)  'Try again please'
      ELSE                              ! IO = 0 means everything is normal
         WRITE(*,*) 'Input item ', Count, ' --> ', X
         IF (X <= 0.0) THEN
            WRITE(*,*) 'Input <= 0.  Ignored'
         ELSE
            TotalValid = TotalValid + 1
            Sum        = Sum + X
            Product    = Product * X
            InverseSum = InverseSum + 1.0/X
         END IF
      END IF
   END DO

   WRITE(*,*)
   IF (TotalValid > 0) THEN
      Arithmetic = Sum / TotalValid
      Geometric  = Product**(1.0/TotalValid)
      Harmonic   = TotalValid / InverseSum

      WRITE(*,*)  '# of items read --> ', Count
      WRITE(*,*)  '# of valid items -> ', TotalValid
      WRITE(*,*)  'Arithmetic mean --> ', Arithmetic
      WRITE(*,*)  'Geometric mean  --> ', Geometric
      WRITE(*,*)  'Harmonic mean   --> ', Harmonic
   ELSE
      WRITE(*,*)  'ERROR: none of the input is positive'
   END IF

END PROGRAM  ComputingMeans

! -------------------------------------------------------
! This program reads in three INTEGERs and displays them 
! in ascending order.
! -------------------------------------------------------
 
PROGRAM  Order
   IMPLICIT  NONE
 
   INTEGER  :: a, b, c

   READ(*,*)  a, b, c

   IF (a <= b .AND. a <= c) THEN   ! a the smallest
      IF (b <= c) THEN             !   a <= b <= c
         WRITE(*,*)  a, b, c
      ELSE                         !   a <= c <= b
         WRITE(*,*)  a, c, b
      END IF
   ELSE IF (b <= a .AND. b <= c) THEN  ! b the smallest
      IF (a <= c) THEN             !   b <= a <= c
         WRITE(*,*)  b, a, c
      ELSE                         !   b <= c <= a
         WRITE(*,*)  b, c, a
      END IF
   ELSE                            ! c the smallest
      IF (a <= b) THEN             !   c <= a <= b
         WRITE(*,*)  c, a, b
      ELSE                         !   c <= b <= a
         WRITE(*,*)  c, b, a
      END IF
   END IF

END PROGRAM  Order

! ---------------------------------------------------------------
! This program contains a function MySqrt() that uses Newton's 
! method to find the square root of a positive number.  This is 
! an iterative method and the program keeps generating better  
! approximation of the square root until two successive 
! approximations have a distance less than the specified tolerance.
! ---------------------------------------------------------------

PROGRAM  SquareRoot
   IMPLICIT  NONE

   REAL    :: Begin, End, Step          
   REAL    :: x, SQRTx, MySQRTx, Error

   READ(*,*)  Begin, End, Step          ! read in init, final and step
   x = Begin                            ! x starts with the init value
   DO
      IF (x > End)  EXIT                ! exit if x > the final value
      SQRTx   = SQRT(x)                 ! find square root with SQRT()
      MySQRTx = MySqrt(x)               ! do the same with my sqrt()
      Error   = ABS(SQRTx - MySQRTx)    ! compute the absolute error
      WRITE(*,*)  x, SQRTx, MySQRTx, Error   ! display the results
      x = x + Step                      ! move on to the next value
   END DO

CONTAINS

! ---------------------------------------------------------------
! REAL FUNCTION  MySqrt()
!    This function uses Newton's method to compute an approximate
! of a positive number.  If the input value is zero, then zero is
! returned immediately.  For convenience, the absolute value of
! the input is used rather than kill the program when the input
! is negative.
! ---------------------------------------------------------------

   REAL FUNCTION  MySqrt(Input)
      IMPLICIT  NONE
      REAL, INTENT(IN) :: Input
      REAL             :: X, NewX
      REAL, PARAMETER  :: Tolerance = 0.00001

      IF (Input == 0.0) THEN            ! if the input is zero
         MySqrt = 0.0                   !    returns zero
      ELSE                              ! otherwise,
         X = ABS(Input)                 !    use absolute value
         DO                             !    for each iteration
            NewX  = 0.5*(X + Input/X)   !       compute a new approximation
            IF (ABS(X - NewX) < Tolerance)  EXIT  ! if very close, exit
            X = NewX                    !       otherwise, keep the new one
         END DO
         MySqrt = NewX
      END IF
   END FUNCTION  MySqrt

END PROGRAM  SquareRoot

! --------------------------------------------------------------------
! PROGRAM  Score_Distribution:
!	Give a set of scores, this program plots a histogram showing the
! number of score in the range of [0,59], [60,69], [70,79], [80,89]
! and [90,100].  The range values (i.e., 60, 70, 80 and 90) are read
! in as input data.  The counting and printing subroutines are moved
! to module Histogram_and_Count in file histo-2m.f90.
! --------------------------------------------------------------------

PROGRAM  Score_Distribution
   USE  Histogram_and_Count
   IMPLICIT   NONE
   INTEGER, PARAMETER         :: SIZE = 20   ! array size
   INTEGER, DIMENSION(1:SIZE) :: Score       ! array containing scores
   INTEGER                    :: ActualSize  ! the # of scores read in
   INTEGER, PARAMETER         :: RANGE_SIZE = 10  ! score range size
   INTEGER, DIMENSION(1:RANGE_SIZE) :: Range ! range of scores
   INTEGER                    :: ActualRange
   INTEGER                    :: i

   READ(*,*)  ActualSize, (Score(i), i = 1, ActualSize)
   WRITE(*,*) "Input Scores:"
   WRITE(*,*) (Score(i), i = 1, ActualSize)
   WRITE(*,*)

   READ(*,*)  ActualRange, (Range(i), i = 1, ActualRange)
   WRITE(*,*) "Input Range:"
   WRITE(*,*) (Range(i), i = 1, ActualRange)
   WRITE(*,*)

   CALL  Distribute(Score, ActualSize, Range, ActualRange)

END PROGRAM  Score_Distribution

! ----------------------------------------------------------
! This program reads three marks, computes their average
! and determines the corresponding letter grade with
! the following table:
!
!         A   : average >= 90
!         AB  : 85 <= average < 90
!         B   : 80 <= average < 84
!         BC  : 75 <= average < 79
!         C   : 70 <= average < 74
!         CD  : 65 <= average < 69
!         D   : 60 <= average < 64
!         F   : average < 60
!
! where 'average' is the rounded average of the three 
! marks.  More precisely, if the average is 78.6, then it
! becomes 79 after rounding; or, if the average is 78.4,
! it becomes 78 after truncating.
! ----------------------------------------------------------

PROGRAM  LetterGrade
   IMPLICIT   NONE

   REAL              :: Mark1, Mark2, Mark3
   REAL              :: Average
   CHARACTER(LEN=2)  :: Grade

   READ(*,*)  Mark1, Mark2, Mark3
   Average = (Mark1 + Mark2 + Mark3) / 3.0

   SELECT CASE (NINT(Average))     ! round Average before use
      CASE (:59)                   ! <= 59 -------------> F
         Grade = 'F '
      CASE (60:64)                 ! >= 60 and <= 64 ---> D
         Grade = 'D '
      CASE (65:69)                 ! >= 65 and <= 69 ---> CD
         Grade = 'CD'
      CASE (70:74)                 ! >= 70 and <= 74 ---> C
         Grade = 'C '
      CASE (75:79)                 ! >= 75 and <= 79 ---> BC
         Grade = 'BC'
      CASE (80:84)                 ! >= 80 and <= 84 ---> B
         Grade = 'B '
      CASE (85:89)                 ! >= 84 and <= 89 ---> AB
         Grade = 'AB'
      CASE DEFAULT                 ! >= 90 -------------> A
         Grade = 'A '
   END SELECT

   WRITE(*,*)  'First Mark    : ', Mark1
   WRITE(*,*)  'Second Mark   : ', Mark2
   WRITE(*,*)  'Third Mark    : ', Mark3
   WRITE(*,*)  'Average       : ', Average
   WRITE(*,*)  'Letter Grade  : ', Grade

END PROGRAM  LetterGrade

! --------------------------------------------------------------------
! MODULE  Sorting:
!    This module can sort a set of numbers.  The method used is
! usually referred to as "selection" method.
! --------------------------------------------------------------------

MODULE  Sorting
   IMPLICIT  NONE
   PRIVATE   :: FindMinimum, Swap

CONTAINS

! --------------------------------------------------------------------
! INTEGER FUNCTION  FindMinimum():
!    This function returns the location of the minimum in the section
! between Start and End.
! --------------------------------------------------------------------

   INTEGER FUNCTION  FindMinimum(x, Start, End)
      IMPLICIT  NONE
      INTEGER, DIMENSION(1:), INTENT(IN) :: x
      INTEGER, INTENT(IN)                :: Start, End
      INTEGER                            :: Minimum
      INTEGER                            :: Location
      INTEGER                            :: i

      Minimum  = x(Start)          ! assume the first is the min
      Location = Start             ! record its position
      DO i = Start+1, End          ! start with next elements
         IF (x(i) < Minimum) THEN  !   if x(i) less than the min?
            Minimum  = x(i)        !      Yes, a new minimum found
            Location = i                !      record its position
         END IF
      END DO
      FindMinimum = Location            ! return the position
   END FUNCTION  FindMinimum

! --------------------------------------------------------------------
! SUBROUTINE  Swap():
!    This subroutine swaps the values of its two formal arguments.
! --------------------------------------------------------------------

   SUBROUTINE  Swap(a, b)
      IMPLICIT  NONE
      INTEGER, INTENT(INOUT) :: a, b
      INTEGER                :: Temp

      Temp = a
      a    = b
      b    = Temp
   END SUBROUTINE  Swap

! --------------------------------------------------------------------
! SUBROUTINE  Sort():
!    This subroutine receives an array x() and sorts it into ascending
! order.
! --------------------------------------------------------------------

   SUBROUTINE  Sort(x, Size)
      IMPLICIT  NONE
      INTEGER, DIMENSION(1:), INTENT(INOUT) :: x
      INTEGER, INTENT(IN)                   :: Size
      INTEGER                               :: i
      INTEGER                               :: Location

      DO i = 1, Size-1             ! except for the last
         Location = FindMinimum(x, i, Size)  ! find min from this to last
         CALL  Swap(x(i), x(Location))  ! swap this and the minimum
      END DO
   END SUBROUTINE  Sort

END MODULE  Sorting

PROGRAM  Decoding
   IMPLICIT  NONE
   CHARACTER(LEN=2)  :: SN_1, SN_2, SN_3*3
   CHARACTER(LEN=3)  :: Phone_1, Phone_2*4
   INTEGER           :: Amount
   INTEGER           :: Number
   INTEGER           :: Status
   LOGICAL           :: Problem
   CHARACTER(LEN=10) :: TitleFormat   = "(T8,A)"
   CHARACTER(LEN=10) :: HeadingFormat = "(T2,A)"
   CHARACTER(LEN=30) :: InputFormat   = "(A2,A2,A3,3X,A3,A4,3X,I5)"
   CHARACTER(LEN=30) :: OutputFormat  = "(1X, 5A, T14, 3A, T26,I6)"
   CHARACTER(LEN=30) :: LastLine      = "(1X, A, I3, A)"

   WRITE(*,TitleFormat)    "Sales Amount Table"
   WRITE(*,TitleFormat)    "=================="
   WRITE(*,*)
   WRITE(*,HeadingFormat)  "Sales No.   Phone No.   Amount"
   WRITE(*,HeadingFormat)  "---------   ---------   ------"
   Problem = .FALSE.
   Number = 0
   DO
      READ(*,InputFormat, IOSTAT=Status)  &
            SN_1, SN_2, SN_3, Phone_1, Phone_2, Amount
      IF (Status > 0) THEN
         WRITE(*,*)  "Something wrong in your input data"
         Problem = .TRUE.
         EXIT
      ELSE IF (Status < 0) THEN
         EXIT
      ELSE
         WRITE(*,OutputFormat)  &
               SN_1, "-", SN_2, "-", SN_3, Phone_1, "-", Phone_2, Amount
         Number = Number + 1
      END IF
   END DO
   IF (.NOT. Problem) THEN
      WRITE(*,*)
      WRITE(*,LastLine)  "Total", Number, " person(s) processed."
   END IF
END PROGRAM  Decoding

! --------------------------------------------------------------------
! MODULE  Histogram_and_Count:
!	This module implements the counting and histogram printing.  Note
! that for the counting part, handled by subroutine Distribute(), two
! more arguments for the range array and its number of entries.  The
! Plot() subroutine now prints a vertical bar histogram.
! --------------------------------------------------------------------

MODULE  Histogram_and_Count
   IMPLICIT  NONE

CONTAINS

! --------------------------------------------------------------------
! SUBROUTINE  Distribute() :
!    This subroutine receives a score array and a range array, counts
! the number of each scores in each range, and calls Plot() to print
! a histogram.
! --------------------------------------------------------------------

   SUBROUTINE  Distribute(X, N, Range, M)
      IMPLICIT NONE
      INTEGER, DIMENSION(1:), INTENT(IN) :: X     ! input score
      INTEGER, INTENT(IN)                :: N     ! # of scores
      INTEGER, DIMENSION(1:), INTENT(IN) :: Range ! range array
      INTEGER, INTENT(IN)                :: M     ! # of ranges
      INTEGER                            :: i, j
      INTEGER, DIMENSION(1:M+1)          :: Bucket! counting bucket

      DO i = 1, M+1                     ! clear buckets
         Bucket(i) = 0
      END DO

      DO i = 1, N                       ! for each input score
         DO j = 1, M                    ! determine the bucket
            IF (X(i) < Range(j)) THEN
               Bucket(j) = Bucket(j) + 1
               EXIT
            END IF
         END DO                         ! don't forget the last bucket
         IF (X(i) >= Range(M))  Bucket(M+1) = Bucket(M+1)+1
      END DO
      CALL  Plot(Bucket, M+1)           ! print a histogram
   END SUBROUTINE  Distribute

! --------------------------------------------------------------------
! SUBROUTINE  Plot() :
!    This subroutine receives a counting array and prints a vertical
! bar histogram.
! --------------------------------------------------------------------

   SUBROUTINE  Plot(Count, K)
      IMPLICIT NONE
      INTEGER, DIMENSION(1:), INTENT(IN) :: Count
      INTEGER, INTENT(IN)                :: K
      CHARACTER(LEN=4), DIMENSION(1:K)   :: Line
      CHARACTER(LEN=4), PARAMETER        :: Division  = "---+"
      CHARACTER(LEN=4), PARAMETER        :: Empty     = "    "
      CHARACTER(LEN=4), PARAMETER        :: EmptyLast = "   |"
      CHARACTER(LEN=4), PARAMETER        :: Data      = "*** "
      CHARACTER(LEN=4), PARAMETER        :: DataLast  = "***|"
      INTEGER                            :: i, j, Maximum

      Maximum = Count(1)                ! find the maximum of the count
      Line(1) = Division                ! clear the print line
      DO i = 2, K
         Line(i) = Division
         IF (Maximum < Count(i))  Maximum = Count(i)
      END DO

      WRITE(*,*) "Histogram:"
      WRITE(*,*)
      WRITE(*,*) "+", (Line(j), j=1,K)  ! print the top border
      DO i = Maximum, 1, -1             ! print from the top
         DO j = 1, K                    ! for each count value
            IF (Count(j) >= i) THEN     !   if >= current value, show ***
               IF (j == K) THEN         !     if this is the last bar
                  Line(j) = DataLast    !       use "***|"
               ELSE                     !     otherwise
                  Line(j) = Data        !       use "*** "
               END IF
            ELSE                        !   if < current value , don't show
               IF (j == K) THEN         !     if this is the last bar
                  Line(j) = EmptyLast   !       use "   |"
               ELSE                     !     otherwise
                  Line(j) = Empty       !       use "    "
               END IF
            END IF
         END DO
         WRITE(*,*) "|", (Line(j), j=1,K)    ! all done.  display this line
      END DO

      DO j = 1, K                       ! prepare and display the lower border
         Line(j) = Division
      END DO
      WRITE(*,*) "+", (Line(j), j=1,K)
   END SUBROUTINE  Plot

END MODULE  Histogram_and_Count

! ---------------------------------------------------------
! This program counts the number of positive and negative
! input values and computes their sums.
! ---------------------------------------------------------

PROGRAM  Counting
   IMPLICIT  NONE

   INTEGER :: Positive, Negative       
   INTEGER :: PosSum, NegSum
   INTEGER :: TotalNumber, Count
   INTEGER :: Data

   Positive = 0                    ! # of positive items
   Negative = 0                    ! # of negative items
   PosSum   = 0                    ! sum of all positive items
   NegSum   = 0                    ! sum of all negative items

   READ(*,*)  TotalNumber          ! read in # of items
   DO Count = 1, TotalNumber       ! for each iteration
      READ(*,*)  Data              !    read an item
      WRITE(*,*) 'Input data ', Count, ': ', Data
      IF (Data > 0) THEN           !    if it is positive
         Positive = Positive + 1   !         count it
         PosSum   = PosSum + Data  !         compute their sum
      ELSE IF (Data < 0) THEN      !    if it is negative
         Negative = Negative + 1   !         count it
         NegSum   = NegSum + Data  !         compute their sum
      END IF
   END DO

   WRITE(*,*)                      ! display results
   WRITE(*,*)  'Counting Report:'
   WRITE(*,*)  '   Positive items = ', Positive, ' Sum = ', PosSum
   WRITE(*,*)  '   Negative items = ', Negative, ' Sum = ', NegSum
   WRITE(*,*)  '   Zero items     = ', TotalNumber - Positive - Negative
   WRITE(*,*)
   WRITE(*,*)  'The total of all input is ', Positive + Negative

END PROGRAM  Counting

! --------------------------------------------------------------------
! Given an integer, this program determines if it is a prime number.
! This program first makes sure the input is 2.  In this case, it is
! a prime number.  Then, it checks to see the input is an even 
! number.  If the input is odd, then this program divides the input
! with 3, 5, 7, ....., until one of two conditions is met:
!    (1)  if one these odd number evenly divides the input, the
!         input is not a prime number;
!    (2)  if the divisor is greater than the square toot of the
!         input, the input is a prime.
! --------------------------------------------------------------------

PROGRAM  Prime
   IMPLICIT  NONE

   INTEGER  :: Number                   ! the input number
   INTEGER  :: Divisor                  ! the running divisor
   
   READ(*,*)  Number                    ! read in the input
   IF (Number < 2) THEN                 ! not a prime if < 2
      WRITE(*,*)  'Illegal input'
   ELSE IF (Number == 2) THEN           ! is a prime if = 2
      WRITE(*,*)  Number, ' is a prime'    
   ELSE IF (MOD(Number,2) == 0) THEN    ! not a prime if even
      WRITE(*,*)  Number, ' is NOT a prime'
   ELSE                                 ! we have an odd number here
      Divisor = 3                       ! divisor starts with 3
      DO                                ! divide the input number
         IF (Divisor*Divisor > Number .OR. MOD(Number, Divisor) == 0)  EXIT
         Divisor = Divisor + 2          ! increase to next odd
      END DO
      IF (Divisor*Divisor > Number) THEN     ! which condition fails?
         WRITE(*,*)  Number, ' is a prime'   
      ELSE
         WRITE(*,*)  Number, ' is NOT a prime'
      END IF
   END IF
END PROGRAM  Prime

! --------------------------------------------------------------------
! PROGRAM  Palindrome:
!    This program checks to see if an array is a palindrome.  An array
! is a palindrome if they read the same in both directions.
! --------------------------------------------------------------------

PROGRAM  Palindrome
   IMPLICIT  NONE

   INTEGER, PARAMETER :: LENGTH = 30    ! maximum array size
   INTEGER, DIMENSION(1:LENGTH) :: x    ! the array
   INTEGER            :: Size           ! actual array size (input)
   INTEGER            :: Head           ! pointer moving forward
   INTEGER            :: Tail           ! pointer moving backward
   INTEGER            :: i              ! running index

   READ(*,*) Size, (x(i), i = 1, Size)  ! read in the input array
   WRITE(*,*)  "Input array:"           ! display the input
   WRITE(*,*)  (x(i), i = 1, Size)

   Head = 1                             ! scan from the beginning
   Tail = Size                          ! scan from the end
   DO                                   ! checking array
      IF (Head >= Tail)  EXIT           !   exit if two pointers meet
      IF (x(Head) /= x(Tail))  EXIT     !   exit if two elements not equal
      Head = Head + 1                   !   equal.  Head moves forward
      Tail = Tail - 1                   !   and Tail moves backward
   END DO                               ! until done

   WRITE(*,*)
   IF (Head >= Tail) THEN               ! if Head cross Tail, then we have
      WRITE(*,*) "The input array is a palindrome"     ! a palindrome
   ELSE                                 ! otherwise, it is not a palindrome
      WRITE(*,*) "The input array is NOT a palindrome"
   END IF

END PROGRAM  Palindrome

PROGRAM  UpperTriangularMatrix
   IMPLICIT   NONE
   INTEGER, PARAMETER                :: SIZE = 10
   INTEGER, DIMENSION(1:SIZE,1:SIZE) :: Matrix
   INTEGER                           :: Number
   INTEGER                           :: Position
   INTEGER                           :: i, j
   CHARACTER(LEN=100)                :: Format

   READ(*,"(I5)")  Number
   DO i = 1, Number
      READ(*,"(10I5)")  (Matrix(i,j), j = 1, Number)
   END DO

   WRITE(*,"(1X,A)")  "Input Matrix:"
   DO i = 1, Number
      WRITE(*,"(1X,10I5)")  (Matrix(i,j), j = 1, Number)
   END DO

   WRITE(*,"(/1X,A)") "Upper Triangular Part:"
   Position = 2
   DO i = 1, Number
      WRITE(Format,"(A,I2.2,A)")  "(T", Position, ", 10I5)"
      WRITE(*,Format)  (Matrix(i,j), j = i, Number)
      Position = Position + 5
   END DO
END PROGRAM  UpperTriangularMatrix

PROGRAM  VerticalBarChart
   IMPLICIT  NONE
   CHARACTER(LEN=*), PARAMETER  :: Part1 = "(1X, I5, A,"
   CHARACTER(LEN=*), PARAMETER  :: Part2 = "A, A, I2, A)"
   CHARACTER(LEN=2)             :: Repetition
   CHARACTER(LEN=10), PARAMETER :: InputFormat = "(I5/(5I5))"
   INTEGER                      :: Number, i, j
   INTEGER, DIMENSION(1:100)    :: Data

   READ(*,InputFormat)  Number, (Data(i), i=1, Number)
   DO i = 1, Number
      IF (Data(i) /= 0) THEN
         WRITE(Repetition,"(I2)")  Data(i)
         WRITE(*,Part1 // Repetition // Part2)  Data(i), " |", ("*", j=1,Data(i)), " (", Data(i), ")"
      ELSE
         WRITE(*,"(1X, I5, A, I2, A)")  Data(i), " | (", Data(i), ")"
      END IF
   END DO
END PROGRAM  VerticalBarChart

      PROGRAM  TestComment1
!        ..........
         READ(*,*)  Year   ! read in the value of Year
!        ..........
         Year = Year + 1   ! add 1 to Year
!        ..........
      END PROGRAM  TestComment1

! --------------------------------------------------------------------
! PROGRAM  MeanVariance:
!    This program reads in an unknown number of real values and
! computes its mean, variance and standard deviation.  It contains
! three subroutines:
!    (1)  Sums()     - computes the sum and sum of squares of the input
!    (2)  Result()   - computes the mean, variance and standard 
!                      deviation from the sum and sum of squares
!    (3)  PrintResult() - print results
! --------------------------------------------------------------------

PROGRAM  MeanVariance
   IMPLICIT   NONE

   INTEGER :: Number, IOstatus
   REAL    :: Data, Sum, Sum2
   REAL    :: Mean, Var, Std

   Number = 0                           ! initialize the counter
   Sum    = 0.0                         ! initialize accumulators
   Sum2   = 0.0

   DO                                   ! loop until done
      READ(*,*,IOSTAT=IOstatus)  Data   ! read in a value
      IF (IOstatus < 0)  EXIT           ! if end-of-file reached, exit
      Number = Number + 1               ! no, have one more value
      WRITE(*,*)  "Data item ", Number, ": ", Data
      CALL  Sums(Data, Sum, Sum2)       ! accumulate the values       
   END DO

   CALL  Results(Sum, Sum2, Number, Mean, Var, Std)  ! compute results
   CALL  PrintResult(Number, Mean, Var, Std)         ! display them

CONTAINS

! --------------------------------------------------------------------
! SUBROUTINE  Sums():
!    This subroutine receives three REAL values:
!    (1)  x      - the input value
!    (2)  Sum    - x will be added to this sum-of-input
!    (3)  SumSQR - x*x is added to this sum-of-squares
! --------------------------------------------------------------------

   SUBROUTINE  Sums(x, Sum, SumSQR)
      IMPLICIT  NONE
      REAL, INTENT(IN)    :: x
      REAL, INTENT(INOUT) :: Sum, SumSQR

      Sum    = Sum + x
      SumSQR = SumSQR + x*x
   END SUBROUTINE  Sums

! --------------------------------------------------------------------
! SUBROUTINE  Results():
!    This subroutine computes the mean, variance and standard deviation
! from the sum and sum-of-squares:
!    (1) Sum       - sum of input values
!    (2) SumSQR    - sun-of-squares
!    (3) n         - number of input data items
!    (4) Mean      - computed mean value
!    (5) Variance  - computed variance
!    (6) StdDev    - computed standard deviation
! --------------------------------------------------------------------

   SUBROUTINE  Results(Sum, SumSQR, n, Mean, Variance, StdDev)
      IMPLICIT  NONE

      INTEGER, INTENT(IN) :: n
      REAL, INTENT(IN)    :: Sum, SumSQR
      REAL, INTENT(OUT)   :: Mean, Variance, StdDev

      Mean = Sum / n
      Variance = (SumSQR - Sum*Sum/n)/(n-1)
      StdDev   = SQRT(Variance)
   END SUBROUTINE

! --------------------------------------------------------------------
! SUBROUTINE  PrintResults():
!    This subroutine displays the computed results.
! --------------------------------------------------------------------

   SUBROUTINE  PrintResult(n, Mean, Variance, StdDev)
      IMPLICIT  NONE

      INTEGER, INTENT(IN) :: n
      REAL, INTENT(IN)    :: Mean, Variance, StdDev

      WRITE(*,*)
      WRITE(*,*) "No. of data items  = ", n
      WRITE(*,*) "Mean               = ", Mean
      WRITE(*,*) "Variance           = ", Variance
      WRITE(*,*) "Standard Deviation = ", StdDev
   END SUBROUTINE  PrintResult

END PROGRAM  MeanVariance

      PROGRAM  MuxTest
        IMPLICIT  NONE

        INTEGER(4), PARAMETER :: SEND_RECV = 1
        INTEGER(4), PARAMETER :: TSUB_ADDR = 16
        INTEGER(4), PARAMETER :: WORD_CT   = 20
        INTEGER(4), PARAMETER :: RT_UP     = 31
        INTEGER(4), PARAMETER :: TERM_ADDR = 28

        CALL SomeRoutine(TERM_ADDR, SEND_RECV, TSUB_ADDR, WORD_CT, RT_UP)
!        CALL SomeRoutine(28, 1, 16, 20, 31)

     END PROGRAM  MuxTest

PROGRAM  ComputeFactorial
   USE       FactorialModule

   IMPLICIT  NONE

   INTEGER :: N, R

   WRITE(*,*)  'Two non-negative integers --> '
   READ(*,*)   N, R

   WRITE(*,*)  N,   '! = ', Factorial(N)
   WRITE(*,*)  R,   '! = ', Factorial(R)

   IF (R <= N) THEN
      WRITE(*,*)  'C(', N, ',', R, ') = ', Combinatorial(N, R)
   ELSE
      WRITE(*,*)  'C(', R, ',', N, ') = ', Combinatorial(R, N)
   END IF

END PROGRAM  ComputeFactorial

! ----------------------------------------------------------
!    This program contains one subroutine for computing the
! arithmetic, geometric and harmonic means of three REALs.
! ----------------------------------------------------------

PROGRAM  Mean6
   IMPLICIT  NONE

   REAL :: u, v, w
   REAL :: ArithMean, GeoMean, HarmMean

   READ(*,*)  u, v, w

   CALL  Means(u, v, w, ArithMean, GeoMean, HarmMean)

   WRITE(*,*) "Arithmetic Mean = ", ArithMean
   WRITE(*,*) "Geometric Mean  = ", GeoMean
   WRITE(*,*) "Harmonic Mean   = ", HarmMean

CONTAINS

! ----------------------------------------------------------
! SUBROUTINE  Means():
!    This subroutine receives three REAL values and computes
! their arithmetic, geometric, and harmonic means.
! ----------------------------------------------------------

   SUBROUTINE  Means(a, b, c, Am, Gm, Hm)
      IMPLICIT  NONE

      REAL, INTENT(IN)  :: a, b, c
      REAL, INTENT(OUT) :: Am, Gm, Hm

      Am = (a + b + c)/3.0
      Gm = (a * b * c)**(1.0/3.0)
      Hm = 3.0/(1.0/a + 1.0/b + 1.0/c)
   END SUBROUTINE  Means

END PROGRAM  Mean6

PROGRAM  ColonTest
   IMPLICIT  NONE
   INTEGER                      :: i, n
   CHARACTER(LEN=15), PARAMETER :: DashLine = "---------------"
   READ(*,*)  n
   WRITE(*,"(1X,5I3/)")   (i, i = 1, n)
   WRITE(*,"(1X,a)")      DashLine
   WRITE(*,"(1X,5I3:/)")  (i, i = 1, n)
   WRITE(*,"(1X,a)")      DashLine
END PROGRAM  ColonTest

! ------------------------------------------------------
! This program reads in a number of integer input until
! a negative one, and determines the minimum and maximum
! of the input data values.
! ------------------------------------------------------

PROGRAM  MinMax
   IMPLICIT  NONE

   INTEGER :: Minimum, Maximum          ! max and min
   INTEGER :: Count                     ! # of data items
   INTEGER :: Input                     ! the input value

   Count = 0                            ! initialize counter
   DO                                   ! for each iteration
      READ(*,*) Input                   !   read in a new input
      IF (Input < 0)  EXIT              !   if it is < 0, done.
      Count = Count + 1                 !   if >= 0, increase counter
      WRITE(*,*)  'Data item #', Count, ' = ', Input
      IF (Count == 1) THEN              !   is this the 1st data?
         Maximum = Input                !     yes, assume it is the
         Minimum = Input                !     min and the max
      ELSE                              !   no, not the 1st data
         IF (Input > Maximum)  Maximum = Input    ! compare against the
         IF (Input < Minimum)  Minimum = Input    ! existing min & max
      END IF
   END DO

   WRITE(*,*)
   IF (Count > 0) THEN                  ! if at one data item found
      WRITE(*,*)  'Found ', Count, ' data items'
      WRITE(*,*)  '  Maximum = ', Maximum
      WRITE(*,*)  '  Minimum = ', Minimum
   ELSE
      WRITE(*,*)  'No data item found.' ! no data item found
   END IF

END PROGRAM  MinMax

      ! This is a comment line
      !
      PROGRAM  TestComment2
!        .........
         ! This is a comment line in the middle of a program
!        .........
      END PROGRAM  TestComment2

<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<HTML><HEAD>
<TITLE>403 Forbidden</TITLE>
</HEAD><BODY>
<H1>Forbidden</H1>
You don't have permission to access /~shene/COURSES/cs201/NOTES/chap09/sums.f90
on this server.<P>
<HR>
<ADDRESS>Apache/1.3.22 Server at www.cs.mtu.edu Port 80</ADDRESS>
</BODY></HTML>

! --------------------------------------------------------------------
! PROGRAM  QuadraticEquation:
!    This program calls subroutine Solver() to solve quadratic
! equations.
! --------------------------------------------------------------------

PROGRAM  QuadraticEquation
   IMPLICIT  NONE

   INTEGER, PARAMETER :: NO_ROOT       = 0   ! possible return types
   INTEGER, PARAMETER :: REPEATED_ROOT = 1
   INTEGER, PARAMETER :: DISTINCT_ROOT = 2

   INTEGER            :: SolutionType        ! return type variable
   REAL               :: a, b, c             ! coefficients
   REAL               :: r1, r2              ! roots

   READ(*,*)  a, b, c                        ! read in coefficients
   CALL  Solver(a, b, c, r1, r2, SolutionType)    ! solve it
   SELECT CASE (SolutionType)                ! select a type
      CASE (NO_ROOT)                         !   no root
         WRITE(*,*)  "The equation has no real root"
      CASE (REPEATED_ROOT)                   !   repeated root
         WRITE(*,*)  "The equation has a repeated root ", r1
      CASE (DISTINCT_ROOT)                   !   distinct roots
         WRITE(*,*)  "The equation has two roots ", r1, " and ", r2
   END SELECT   

CONTAINS

! --------------------------------------------------------------------
! SUBROUTINE  Solver():
!    This subroutine takes the coefficients of a quadratic equation
! and solve it.  It returns three values as follows:
!    (1) Type   - if the equation has no root, a repeated root, or 
!                 distinct roots, this formal arguments returns NO_ROOT,
!                 REPEATED_ROOT and DISTINCT_ROOT, respectively. 
!                 Note that these are PARAMETERS declared in the main
!                 program.
!    (2) Root1 and Root2 -  if there is no real root, these two formal
!                 arguments return 0.0.  If there is a repeated
!                 root, Root1 returns the root and Root2 is zero.  
!                 Otherwise, both Root1 and Root2 return the roots.
! --------------------------------------------------------------------

   SUBROUTINE  Solver(a, b, c, Root1, Root2, Type)
      IMPLICIT  NONE

      REAL, INTENT(IN)     :: a, b, c
      REAL, INTENT(OUT)    :: Root1, Root2
      INTEGER, INTENT(OUT) :: Type

      REAL                 :: d		! the discriminant

      Root1 = 0.0                       ! set the roots to zero
      Root2 = 0.0
      d     = b*b - 4.0*a*c             ! compute the discriminant
      IF (d < 0.0) THEN                 ! if the discriminant < 0
         Type  = NO_ROOT                !    no root
      ELSE IF (d == 0.0) THEN           ! if the discriminant is 0
         Type  = REPEATED_ROOT          !    a repeated root
         Root1 = -b/(2.0*a)
      ELSE                              ! otherwise, 
         Type  = DISTINCT_ROOT          !    two distinct roots
         d     = SQRT(d)
         Root1 = (-b + d)/(2.0*a)
         Root2 = (-b - d)/(2.0*a)
      END IF
   END SUBROUTINE  Solver

END PROGRAM  QuadraticEquation

! ---------------------------------------------------------
! This program uses Newton's method to find the square
! root of a positive number.  This is an iterative method
! and the program keeps generating better approximation
! of the square root until two successive approximations
! have a distance less than the specified tolerance.
! ---------------------------------------------------------

PROGRAM  SquareRoot
   IMPLICIT  NONE

   REAL    :: Input, X, NewX, Tolerance
   INTEGER :: Count

   READ(*,*)  Input, Tolerance

   Count = 0                            ! count starts with 0
   X     = Input                        ! X starts with the input value
   DO                                   ! for each iteration
      Count = Count + 1                 !    increase the iteration count
      NewX  = 0.5*(X + Input/X)         !    compute a new approximation
      IF (ABS(X - NewX) < Tolerance)  EXIT   ! if they are very close, exit
      X = NewX                          !    otherwise, keep the new one
   END DO

   WRITE(*,*)  'After ', Count, ' iterations:'
   WRITE(*,*)  '  The estimated square root is ', NewX
   WRITE(*,*)  '  The square root from SQRT() is ', SQRT(Input)
   WRITE(*,*)  '  Absolute error = ', ABS(SQRT(Input) - NewX)

END PROGRAM  SquareRoot

PROGRAM  Input_1
   IMPLICIT  NONE
   CHARACTER(LEN=25) :: Name, ClassAverage
   CHARACTER(LEN=30) :: FormatIn, FormatOut, FormatAvg
   INTEGER           :: Number, i
   INTEGER           :: Score1, Score2, Score3
   REAL              :: Average
   REAL              :: Score1Avg, Score2Avg, Score3Avg, ClassAvg

   FormatIn  = "(A25, 3I5)"
   FormatOut = "(A, A25, 3I8, F9.2)"
   FormatAvg = "(A, A25, 3F8.2, F9.2)"
   WRITE(*,"(2A)")  " ", "Name                       Score1  Score2  Score3  Average"
   WRITE(*,"(2A)")  " ", "=========================  ======  ======  ======  ======="
   ClassAverage = "Average"
   Score1Avg    = 0.0
   Score2Avg    = 0.0
   Score3Avg    = 0.0
   READ(*,*)  Number
   DO i = 1, Number
      READ(*,FormatIn)  Name, Score1, Score2, Score3
      Average = REAL(Score1 + Score2 + Score3) / 3.0
      WRITE(*,FormatOut)  " ", Name, Score1, Score2, Score3, Average
      Score1Avg = Score1Avg + Score1
      Score2Avg = Score2Avg + Score2
      Score3Avg = Score3Avg + Score3
   END DO
   Score1Avg = Score1Avg / Number
   Score2Avg = Score2Avg / Number
   Score3Avg = Score3Avg / Number
   ClassAvg  = (Score1Avg + Score2Avg + Score3Avg) / 3.0
   WRITE(*,"(2A)")     " ", "=========================  ======  ======  ======  ======="
   WRITE(*,FormatAvg)  " ", ClassAverage, Score1Avg, Score2Avg, Score3Avg, ClassAvg
END PROGRAM  Input_1

! ----------------------------------------------------------
! Given a non-negative integer N, this program computes
! the factorial of N.  The factorial of N, N!, is defined as
!         N! = 1 x 2 x 3 x .... x (N-1) x N
! and 0! = 1.
! ----------------------------------------------------------

PROGRAM  Factorial
   IMPLICIT  NONE

   INTEGER :: N, i, Answer

   WRITE(*,*)  'This program computes the factorial of'
   WRITE(*,*)  'a non-negative integer'
   WRITE(*,*)
   WRITE(*,*)  'What is N in N! --> '
   READ(*,*)   N
   WRITE(*,*)

   IF (N < 0) THEN                 ! input error if N < 0
      WRITE(*,*)  'ERROR: N must be non-negative'
      WRITE(*,*)  'Your input N = ', N
   ELSE IF (N == 0) THEN           ! 0! = 1
      WRITE(*,*)  '0! = 1'
   ELSE                            ! N > 0 here
      Answer = 1                   ! initially N! = 1
      DO i = 1, N                  ! for each i = 1, 2, ..., N
         Answer = Answer * i       ! multiply i to Answer
      END DO
      WRITE(*,*)  N, '! = ', Answer
   END IF

END PROGRAM  Factorial

! ---------------------------------------------------------
! This program computes the GCD of two positive integers
! using the Euclid method.  Given a and b, a >= b, the 
! Euclid method goes as follows:  (1) dividing a by b yields 
! a reminder c; (2) if c is zero, b is the GCD; (3) if c is
! no zero, b becomes a and c becomes c and go back to
! Step (1).  This process will continue until c is zero.
!
! Euclid's algorithm is implemented as an INTEGER function
! GCD().
! ---------------------------------------------------------

PROGRAM  GreatestCommonDivisor
   IMPLICIT  NONE

   INTEGER   :: a, b

   WRITE(*,*) 'Two positive integers please --> '
   READ(*,*)  a, b
   WRITE(*,*) 'The GCD of is ', GCD(a, b)

CONTAINS

! ---------------------------------------------------------
! INTEGER FUNCTION  GCD():
!    This function receives two INTEGER arguments and
! computes their GCD.
! ---------------------------------------------------------

   INTEGER FUNCTION  GCD(x, y)
      IMPLICIT  NONE

      INTEGER, INTENT(IN) :: x, y       ! we need x and y here
      INTEGER             :: a, b, c

      a = x                   ! if x <= y, swap x and y
      b = y                   ! since x and y are declared with
      IF (a <= b) THEN        ! INTENT(IN), they cannot be 
         c = a                ! involved in this swapping process.
         a = b                ! So, a, b and c are used instead.
         b = c
      END IF

      DO              
         c = MOD(a, b)
         IF (c == 0) EXIT
         a = b           
         b = c           
      END DO             

      GCD = b
   END FUNCTION  GCD

END PROGRAM  GreatestCommonDivisor

! ---------------------------------------------------------------
! This program computes all Armstrong numbers in the range of 
! 0 and 999.  An Armstrong number is a number such that the sum
! of its digits raised to the third power is equal to the number
! itself.  For example, 371 is an Armstrong number, since
! 3**3 + 7**3 + 1**3 = 371.
! ---------------------------------------------------------------

PROGRAM  ArmstrongNumber
   IMPLICIT  NONE

   INTEGER :: a, b, c                   ! the three digits
   INTEGER :: abc, a3b3c3               ! the number and its cubic sum
   INTEGER :: Count                     ! a counter

   Count = 0
   DO a = 0, 9                          ! for the left most digit
      DO b = 0, 9                       !   for the middle digit
         DO c = 0, 9                    !     for the right most digit
            abc    = a*100 + b*10 + c   !        the number
            a3b3c3 = a**3 + b**3 + c**3 !        the sum of cubes
            IF (abc == a3b3c3) THEN     !        if they are equal
               Count = Count + 1        !           count and display it
               WRITE(*,*)  'Armstrong number ', Count, ': ', abc
            END IF
         END DO
      END DO
   END DO

END PROGRAM  ArmstrongNumber

! --------------------------------------------------------------------
! PROGRAM  Histogram:
!    Given a set of scores, this program plots a histogram showing the
! number of score in the range of [0,59], [60,69], [70,79], [80,89]
! and [90,100].  In subroutine Distribute() a local array is used
! to store these counts which is, in turn, sent to subroutine
! Plot() for plotting.
! --------------------------------------------------------------------

PROGRAM  Histogram
   IMPLICIT NONE
   INTEGER, PARAMETER         :: SIZE = 20   ! array size
   INTEGER, DIMENSION(1:SIZE) :: Score       ! array containing scores
   INTEGER                    :: ActualSize  ! the # of scores read in
   INTEGER                    :: i

   READ(*,*)  ActualSize, (Score(i), i = 1, ActualSize)
   WRITE(*,*) "Input Scores:"
   WRITE(*,*) (Score(i), i = 1, ActualSize)
   WRITE(*,*)

   CALL  Distribute(Score, ActualSize)

CONTAINS

! --------------------------------------------------------------------
! SUBROUTINE  Distribute() :
!    This subroutine receives a set of scores and count the number of
! scores in the range of [0,59], [60,69], [70,79], [80,89] and
! [90,100].  A local array is used to accumulate these counts.
! --------------------------------------------------------------------

   SUBROUTINE  Distribute(X, N)
      IMPLICIT NONE
      INTEGER, DIMENSION(1:), INTENT(IN) :: X
      INTEGER, INTENT(IN)                :: N
      INTEGER, PARAMETER                 :: Bucket_Size = 5
      INTEGER, DIMENSION(1:Bucket_Size)  :: Bucket
      INTEGER                            :: i

      DO i = 1, Bucket_Size             ! clear the local array
         Bucket(i) = 0
      END DO

      DO i = 1, N                       ! for each score ...
         SELECT CASE (X(i))             !    determine the range it lies
            CASE (:59)
               Bucket(1) = Bucket(1) + 1
            CASE (60:69)
               Bucket(2) = Bucket(2) + 1
            CASE (70:79)
               Bucket(3) = Bucket(3) + 1
            CASE (80:89)
               Bucket(4) = Bucket(4) + 1
            CASE (90:)
               Bucket(5) = Bucket(5) + 1
         END SELECT
      END DO
      CALL  Plot(Bucket, Bucket_Size)   ! send the count to Plot()
   END SUBROUTINE  Distribute

! --------------------------------------------------------------------
! SUBROUTINE  Plot() :
!    This subroutine receives a set of count from an array and for
! each count, displays that number of '*'s on the same line.  Thus,
! the result is a histogram.
! --------------------------------------------------------------------

   SUBROUTINE  Plot(Input, Size)
      IMPLICIT NONE
      INTEGER, DIMENSION(1:), INTENT(IN) :: Input
      INTEGER, INTENT(IN)                :: Size
      INTEGER                            :: i, j

      WRITE(*,*) "Histogram:"
      WRITE(*,*)
      DO i = 1, Size
         WRITE(*,*)  ('*', j=1,Input(i)), ' (', Input(i), ')'
      END DO
   END SUBROUTINE  Plot

END PROGRAM  Histogram

! --------------------------------------------------------------------
!    This program uses Heron's formula to compute the area of a
! triangle.  It "contains" the following functions;
!    (1)  LOGICAL function TriangleTest() -
!         this function has three real formal arguments and tests
!         to see if they can form a triangle.  If they do form a
!         triangle, this function returns .TRUE.; otherwise, it
!         returns .FALSE.
!    (2)  REAL function TriangleArea() -
!         this functions has three real formal arguments considered
!         as three sides of a triangle and returns the area of this
!         triangle.
! --------------------------------------------------------------------

PROGRAM  HeronFormula
   IMPLICIT  NONE

   INTERFACE
      LOGICAL FUNCTION  TriangleTest(a, b, c)
         REAL, INTENT(IN) :: a, b, c
      END FUNCTION  TriangleTest

      REAL FUNCTION  Area(a, b, c)
         REAL, INTENT(IN) :: a, b, c
      END FUNCTION  Area
   END INTERFACE

   REAL :: a, b, c, TriangleArea

   DO
      WRITE(*,*)  'Three sides of a triangle please --> '
      READ(*,*)   a, b, c
      WRITE(*,*)  'Input sides are ', a, b, c
      IF (TriangleTest(a, b, c))  EXIT  ! exit if not a triangle
      WRITE(*,*)  'Your input CANNOT form a triangle.  Try again'
   END DO

   TriangleArea = Area(a, b, c)
   WRITE(*,*)  'Triangle area is ', TriangleArea

END PROGRAM  HeronFormula

! --------------------------------------------------------------------
! LOGICAL FUNCTION  TriangleTest() :
!    This function receives three REAL numbers and tests if they form
! a triangle by testing:
!    (1)  all arguments must be positive, and
!    (2)  the sum of any two is greater than the third
! If the arguments form a triangle, this function returns .TRUE.;
! otherwise, it returns .FALSE.
! --------------------------------------------------------------------
   
LOGICAL FUNCTION  TriangleTest(a, b, c)
   IMPLICIT  NONE

   REAL, INTENT(IN) :: a, b, c
   LOGICAL          :: test1, test2

   test1 = (a > 0.0) .AND. (b > 0.0) .AND. (c > 0.0)
   test2 = (a + b > c) .AND. (a + c > b) .AND. (b + c > a)
   TriangleTest = test1 .AND. test2  ! both must be .TRUE.
END FUNCTION  TriangleTest

! --------------------------------------------------------------------
! REAL FUNCTION  Area() :
!    This function takes three real number that form a triangle, and
! computes and returns the area of this triangle using Heron's formula.
! --------------------------------------------------------------------

REAL FUNCTION  Area(a, b, c)
   IMPLICIT  NONE

   REAL, INTENT(IN) :: a, b, c
   REAL             :: s

   s    = (a + b + c) / 2.0
   Area = SQRT(s*(s-a)*(s-b)*(s-c))
END FUNCTION  Area

      PROGRAM    continuation_lines
         IMPLICIT   NONE
!        [specification part]
!        [execution part]
      ! In Fortran, a statement must start on a new line. If a statement is 
      ! too long to fit on a line, it can be continued with the following methods:

      ! If a line is ended with an ampersand, &, it will be continued on the next line.
      ! Continuation is normally to the first character of the next non-comment line.

          A = 174.5 * Year   &
              + Count / 100

      ! The above is equivalent to the following

          A = 174.5 * Year  + Count / 100

      ! Note that & is not part of the statement.

          A = 174.5 * Year   &
          !  this is a comment line
              + Count / 100

      ! The above is equivalent to the following, since the comment is 
      ! ignored by the compiler:

          A = 174.5 * Year  + Count / 100

      ! If the first non-blank character of the continuation line is &, 
      ! continuation is to the first character after the &:

          A = 174.5 + ThisIsALong&
               &VariableName * 123.45

      ! is equivalent to

          A = 174.5 + ThisIsALongVariableName * 123.45

      ! In this case, there should be no spaces between the last character and 
      ! the & on the first line. For example,

          A = 174.5 + ThisIsALong   &
               &VariableName * 123.45

      ! is equivalent to

          A = 174.5 + ThisIsALong   VariableName * 123.45

      ! Note that there are spaces between ThisIsALong and VariableName. In 
      ! this way, a token (name and number) can be split over two lines. 
      ! However, this is not recommended
!        [subprogram part]
      END PROGRAM continuation_lines

PROGRAM  Six_Per_Row
   IMPLICIT  NONE
   INTEGER, PARAMETER         :: SIZE = 20
   INTEGER, DIMENSION(1:SIZE) :: x
   INTEGER                    :: i
   CHARACTER(LEN=80)          :: String

   String = "(1X, A/ 1X, A // (1X, 6I4))"

   DO i = 1, SIZE
      x(i) = MOD(i, 5) + i
   END DO

   WRITE(*,String) 'Generated Table',  &
                   '---------------',  &
                   (x(i), i = 1, SIZE)

END PROGRAM  Six_Per_Row

! --------------------------------------------------------------------
! PROGRAM  Grading:
!    This program reads in a set of values, computes its mean,
! variance, and standard deviation, and use the mean and standard
! deviation to compute a letter grade.
!    This program shows you the easy way of passing arrays as 
! arguments.  Lower bound and upper bound are passed.
! --------------------------------------------------------------------

PROGRAM  Grading
   IMPLICIT  NONE

   INTEGER, PARAMETER :: MAX_SIZE = 100
   REAL, DIMENSION(1:MAX_SIZE) :: InputData
   INTEGER                     :: ActualSize

   CALL  ReadArray(InputData, MAX_SIZE, ActualSize)
   CALL  DisplayResult(InputData, MAX_SIZE, ActualSize)

CONTAINS

! --------------------------------------------------------------------
! SUBROUTINE  ReadArray():
!    This subroutine reads in the number of data and the data set.
! --------------------------------------------------------------------

   SUBROUTINE ReadArray(x, SIZE, n)
      IMPLICIT  NONE
      INTEGER, INTENT(IN)                  :: SIZE
      INTEGER, INTENT(OUT)                 :: n
      REAL, DIMENSION(1:SIZE), INTENT(OUT) :: x
      INTEGER                              :: i

      READ(*,*)  n
      READ(*,*)  (x(i), i = 1, n)
   END SUBROUTINE  ReadArray

! --------------------------------------------------------------------
! SUBROUTINE  DisplayResult():
!    This subroutine calls MeanVariance() to compute the mean,
! variance and standard deviation, and prints a grade report.  The
! letter grade is determined by CHARACTER function LetterGrade().
! --------------------------------------------------------------------

   SUBROUTINE  DisplayResult(Data, SIZE, n)
      IMPLICIT  NONE
      INTEGER, INTENT(IN)                 :: SIZE
      INTEGER, INTENT(IN)                 :: n
      REAL, DIMENSION(1:SIZE), INTENT(IN) :: Data
      INTEGER                             :: i
      REAL                                :: Mean, Var, Std

      CALL  MeanVariance(Data, SIZE, n, Mean, Var, Std)
      WRITE(*,*)  "Grading Report"
      WRITE(*,*)
      DO i = 1, n
         WRITE(*,*) Data(i), "  ", LetterGrade(Data(i), Mean, Std)
      END DO
      WRITE(*,*)
      WRITE(*,*)  "No. of students          = ", n
      WRITE(*,*)  "Class average            = ", Mean
      WRITE(*,*)  "Class variance           = ", Var
      WRITE(*,*)  "Class standard deviation = ", Std
   END SUBROUTINE  DisplayResult

! --------------------------------------------------------------------
! CHARACTER FUNCTION  LetterGrade():
!    This function receives a score and the mean and standard deviation
! values, and returns a letter grade.
! --------------------------------------------------------------------

   CHARACTER FUNCTION  LetterGrade(x, Mean, StdDev)
      IMPLICIT  NONE
      REAL, INTENT(IN) :: x, Mean, StdDev

      IF (x < Mean - 1.5*StdDev) THEN
         LetterGrade = "F"
      ELSE IF (x < Mean - 0.5*StdDev) THEN
         LetterGrade = "D"
      ELSE IF (x < Mean + 0.5*StdDev) THEN
         LetterGrade = "C"
      ELSE IF (x < 1.5*StdDev) THEN
         LetterGrade = "B"
      ELSE
         LetterGrade = "A"
      END IF
   END FUNCTION  LetterGrade

! --------------------------------------------------------------------
! SUBROUTINE  MeanVariance():
!    This subroutine computes the mean, variance and standard
! deviation.
! --------------------------------------------------------------------

   SUBROUTINE  MeanVariance(Data, SIZE, n, Mean, Variance, StdDev)
      IMPLICIT  NONE
      INTEGER, INTENT(IN)                 :: SIZE
      INTEGER, INTENT(IN)                 :: n
      REAL, DIMENSION(1:SIZE), INTENT(IN) :: Data
      REAL, INTENT(OUT)                   :: Mean, Variance, StdDev
      INTEGER                             :: i

      Mean = 0.0
      DO i = 1, n
         Mean = Mean + Data(i)
      END DO
      Mean = Mean / n

      Variance = 0.0
      DO i = 1, n
         Variance = Variance + (Data(i) - Mean)**2
      END DO
      Variance = Variance / n
      StdDev   = SQRT(Variance)
   END SUBROUTINE  MeanVariance

END PROGRAM  Grading

! ---------------------------------------------------
!   Solve  Ax^2 + Bx + C = 0 given B*B-4*A*C >= 0   
! ---------------------------------------------------
 
PROGRAM  QuadraticEquation
   IMPLICIT  NONE

   REAL  :: a, b, c
   REAL  :: d
   REAL  :: root1, root2
   
!  read in the coefficients a, b and c

   WRITE(*,*) 'A, B, C Please : '
   READ(*,*)  a, b, c

!  compute the square root of discriminant d

   d  = SQRT(b*b - 4.0*a*c)
   
!  solve the equation

   root1 = (-b + d)/(2.0*a)   ! first root
   root2 = (-b - d)/(2.0*a)   ! second root

!  display the results

   WRITE(*,*)
   WRITE(*,*)  'Roots are ', root1, ' and ', root2

END PROGRAM  QuadraticEquation

PROGRAM  CheckBook
   IMPLICIT   NONE
   CHARACTER(LEN=1)  :: Code
   CHARACTER(LEN=15) :: Line
   INTEGER           :: Payment, Deposit, Balance, Input
   INTEGER           :: Count
   INTEGER           :: Status
   CHARACTER(LEN=*), PARAMETER :: Filler      = "   *******"
   CHARACTER(LEN=*), PARAMETER :: DashLine    = "-----------------------------------"
   CHARACTER(LEN=*), PARAMETER :: TitleFormat = "(1X, A/1X, A//1X, A/1X, A)"
   CHARACTER(LEN=*), PARAMETER :: InputLine   = "(A)"
   CHARACTER(LEN=*), PARAMETER :: CheckLine   = "(1X, A/ 1X, I5, SP, 3I10/1X, A)"
   CHARACTER(LEN=*), PARAMETER :: PaymentLine = "(1X, I5, SP, I10, A, I10)"
   CHARACTER(LEN=*), PARAMETER :: DepositLine = "(1X, I5, A, SP, 2I10)"
   CHARACTER(LEN=*), PARAMETER :: LastLine    = "(1X, A/ 1X, A, SP, 3I10)"

   WRITE(*,TitleFormat)  "Check Book Reference Listing",        &
                         "============================",        &
                         "Count   Payment   Deposit   Balance", &
                         "-----   -------   -------   -------"

   Payment = 0
   Deposit = 0
   Balance = 0
   Count   = 0
   DO
      READ(*,InputLine,IOSTAT=Status)  Line
      IF (Status < 0)  EXIT
      Code  = Line(1:1)
      Count = Count + 1
      SELECT CASE (Code)
         CASE("C", "c")
            WRITE(*,CheckLine)  DashLine, Count, Payment, Deposit, Balance, DashLine
         CASE("P", "p")
            READ(Line,"(T11,I5)")  Input
            Payment = Payment + Input
            Balance = Balance - Input
            WRITE(*,PaymentLine)  Count, Input, Filler, Balance
         CASE("D", "d")
            READ(Line,"(T6,I5)")   Input
            Deposit = Deposit + Input
            Balance = Balance + Input
            WRITE(*,DepositLine)  Count, Filler, Input, Balance
      END SELECT
   END DO

   WRITE(*,LastLine)  DashLine, "Total", Payment, Deposit, Balance
END PROGRAM  CheckBook

PROGRAM  Decoding
   IMPLICIT  NONE
   INTEGER :: SalesNo, Phone, Amount
   INTEGER :: SN_1, SN_2, SN_3
   INTEGER :: Phone_1, Phone_2
   INTEGER :: Number
   INTEGER :: Status
   LOGICAL :: Problem

   WRITE(*,"(A,A)")  " ", "      Sales Amount Table"
   WRITE(*,"(A,A)")  " ", "      =================="
   WRITE(*,*)
   WRITE(*,"(A, A)")  " ", "Sales No.   Phone No.   Amount"
   WRITE(*,"(A, A)")  " ", "---------   ---------   ------"
   Problem = .FALSE.
   Number = 0
   DO
      READ(*,"(I10,I10,I5)", IOSTAT=Status)  SalesNo, Phone, Amount
      IF (Status > 0) THEN
         WRITE(*,*)  "Something wrong in your input data"
         Problem = .TRUE.
         EXIT
      ELSE IF (Status < 0) THEN
         EXIT
      ELSE
         SN_3 = MOD(SalesNo, 1000)
         SN_2 = MOD(SalesNo/1000,100)
         SN_1 = SalesNo/100000

         Phone_2 = MOD(Phone, 10000)
         Phone_1 = Phone / 10000
         WRITE(*,"(A,I2.2,A,I2.2,A,I3.3,I6.3,A,I4.4,I10)")  &
            " ", SN_1, "-", SN_2, "-", SN_3, Phone_1, "-", Phone_2, Amount
         Number = Number + 1
      END IF
   END DO
   IF (.NOT. Problem) THEN
      WRITE(*,*)
      WRITE(*,"(A,A,I3,A)")  " ", "Total", Number, " person(s) processed."
   END IF
END PROGRAM  Decoding

! ------------------------------------------------------------
! This program reads in a single character and determines if
! it is a vowel, a consonant, a digit, one of the four 
! arithmetic operators (+, -, * and /), a space, or something
! else.  You can do it with IF-THEN-ELSE-END IF statement; but
! SELECT CASE statement provides a cleaner solution.
!
! For character input, you could use the quote characters like
!         'G'  
! Or, just type the character.  In this case, the first 
! character you type will be read.
! ------------------------------------------------------------

PROGRAM  CharacterTesting
   IMPLICIT  NONE

   CHARACTER(LEN=1) :: Input

   READ(*,*)  Input

   SELECT CASE (Input)
      CASE ('A' : 'Z', 'a' : 'z')       ! rule out letters
         WRITE(*,*)  'A letter is found : "', Input, '"'
         SELECT CASE (Input)            ! a vowel ?
            CASE ('A', 'E', 'I', 'O', 'U', 'a', 'e', 'i', 'o','u')
               WRITE(*,*)  'It is a vowel'
            CASE DEFAULT                ! it must be a consonant
               WRITE(*,*)  'It is a consonant'
         END SELECT
      CASE ('0' : '9')                  ! a digit
         WRITE(*,*)  'A digit is found : "', Input, '"'
      CASE ('+', '-', '*', '/')         ! an operator
         WRITE(*,*)  'An operator is found : "', Input, '"'
      CASE (' ')                        ! space
         WRITE(*,*)  'A space is found : "', Input, '"'
      CASE DEFAULT                      ! something else
         WRITE(*,*)  'Something else found : "', Input, '"'
   END SELECT

END PROGRAM  CharacterTesting

PROGRAM  Means
   IMPLICIT  NONE
   REAL                        :: a, b, c
   REAL                        :: Am, Gm, Hm
   CHARACTER(LEN=*), PARAMETER :: FMT = "(1X, A//3(1X, A, F15.7/))"

   READ(*,*) a, b, c
   Am = (a + b + c)/3.0
   Gm = (a * b * c)**(1.0/3.0)
   Hm = 3.0 / (1.0/a + 1.0/b + 1.0/c)
   WRITE(*,FMT) "Input Data",   &
                "a = ", a,      &
                "b = ", b,      &
                "c = ", c
   WRITE(*,FMT) "Computed Results",  &
                "Arithmetic Mean = ", Am, &
                "Geometric Mean  = ", Gm, &
                "Harmonic Mean   = ", Hm

END PROGRAM  Means

! ------------------------------------------------------
! Compute the area of a triangle using Heron's formula
! ------------------------------------------------------

PROGRAM  HeronFormula
   IMPLICIT  NONE

   REAL     :: a, b, c             ! three sides
   REAL     :: s                   ! half of perimeter
   REAL     :: Area                ! triangle area
   LOGICAL  :: Cond_1, Cond_2      ! two logical conditions

   READ(*,*)  a, b, c

   WRITE(*,*)  "a = ", a
   WRITE(*,*)  "b = ", b
   WRITE(*,*)  "c = ", c
   WRITE(*,*)

   Cond_1 = (a > 0.) .AND. (b > 0.) .AND. (c > 0.0)
   Cond_2 = (a+b > c) .AND. (a+c > b) .AND. (b+c > a)
   IF (Cond_1 .AND. Cond_2) THEN
      s    = (a + b + c) / 2.0
      Area = SQRT(s*(s-a)*(s-b)*(s-c))
      WRITE(*,*) "Triangle area = ", Area
   ELSE
      WRITE(*,*) "ERROR: this is not a triangle!"
   END IF

END PROGRAM  HeronFormula

PROGRAM  Multiplication_Table
   IMPLICIT  NONE
   INTEGER, PARAMETER :: MAX = 9
   INTEGER            :: i, j
   CHARACTER(LEN=80)  :: FORMAT

   FORMAT = "(9(2X, I1, A, I1, A, I2))"
   DO i = 1, MAX
      WRITE(*,FORMAT) (i, '*', j, '=', i*j, j = 1, MAX)
   END DO
END PROGRAM  Multiplication_Table

! -----------------------------------------------------------------------
! PROGRAM  TrigonFunctTest:
!    This program tests the functions in module MyTrigonometricFunctions.
! Module MyTrigonometricFunctions is stored in file trigon.f90.
! Functions in that module use degree rather than radian.  This program
! displays the sin(x) and cos(x) values for x=-180, -170, ..., 0, 10, 20,
! 30, ..., 160, 170 and 180.  Note that the sin() and cos() function
! in module MyTrigonometricFunctions are named MySIN(x) and MyCOS(x).
! -----------------------------------------------------------------------

PROGRAM  TrigonFunctTest
   USE  MyTrigonometricFunctions        ! use a module

   IMPLICIT  NONE

   REAL :: Begin = -180.0               ! initial value
   REAL :: Final =  180.0               ! final value
   REAL :: Step  =   10.0               ! step size
   REAL :: x

   WRITE(*,*)  'Value of PI = ', PI
   WRITE(*,*)
   x = Begin                            ! start with 180 degree
   DO
      IF (x > Final)  EXIT              ! if x > 180 degree, EXIT
      WRITE(*,*)  'x = ',  x, 'deg   sin(x) = ', MySIN(x), &
                  '   cos(x) = ', MyCOS(x)
      x = x + Step                      ! advance x
   END DO

END PROGRAM  TrigonFunctTest
   

! -----------------------------------------------------------
!   Calculate the length of a parabola given height and base.                                         *
! -----------------------------------------------------------

PROGRAM  ParabolaLength
   IMPLICIT  NONE

   REAL  :: Height, Base, Length
   REAL  :: temp, t

   WRITE(*,*)  'Height of a parabola : '
   READ(*,*)   Height

   WRITE(*,*)  'Base of a parabola   : '
   READ(*,*)   Base

! ... temp and t are two temporary variables

   t      = 2.0 * Height
   temp   = SQRT(t**2 + Base**2)
   Length = temp + Base**2/t*LOG((t + temp)/Base)

   WRITE(*,*)
   WRITE(*,*)  'Height = ', Height
   WRITE(*,*)  'Base   = ', Base
   WRITE(*,*)  'Length = ', Length

END PROGRAM  ParabolaLength

! --------------------------------------------------------------------
! PROGRAM  Sorting:
!    This program can sort a set of numbers.  The method used is 
! usually referred to as "selection" method.
! --------------------------------------------------------------------

PROGRAM  Sorting
   IMPLICIT  NONE
   INTEGER, PARAMETER :: MAX_SIZE = 100
   INTEGER, DIMENSION(1:MAX_SIZE) :: InputData
   INTEGER                        :: ActualSize
   INTEGER                        :: i

   READ(*,*)  ActualSize, (InputData(i), i = 1, ActualSize)
   WRITE(*,*) "Input Array:"
   WRITE(*,*) (InputData(i), i = 1, ActualSize)
   
   CALL  Sort(InputData, ActualSize)

   WRITE(*,*)
   WRITE(*,*) "Sorted Array:"
   WRITE(*,*) (InputData(i), i = 1, ActualSize)

CONTAINS

! --------------------------------------------------------------------
! INTEGER FUNCTION  FindMinimum():
!    This function returns the location of the minimum in the section
! between Start and End.
! --------------------------------------------------------------------

   INTEGER FUNCTION  FindMinimum(x, Start, End)
      IMPLICIT  NONE
      INTEGER, DIMENSION(1:), INTENT(IN) :: x
      INTEGER, INTENT(IN)                :: Start, End
      INTEGER                            :: Minimum
      INTEGER                            :: Location
      INTEGER                            :: i

      Minimum  = x(Start)		! assume the first is the min
      Location = Start			! record its position
      DO i = Start+1, End		! start with next elements
         IF (x(i) < Minimum) THEN	!   if x(i) less than the min?
            Minimum  = x(i)		!      Yes, a new minimum found
            Location = i                !      record its position
         END IF
      END DO
      FindMinimum = Location        	! return the position
   END FUNCTION  FindMinimum

! --------------------------------------------------------------------
! SUBROUTINE  Swap():
!    This subroutine swaps the values of its two formal arguments.
! --------------------------------------------------------------------

   SUBROUTINE  Swap(a, b)
      IMPLICIT  NONE
      INTEGER, INTENT(INOUT) :: a, b
      INTEGER                :: Temp

      Temp = a
      a    = b
      b    = Temp
   END SUBROUTINE  Swap

! --------------------------------------------------------------------
! SUBROUTINE  Sort():
!    This subroutine receives an array x() and sorts it into ascending
! order.
! --------------------------------------------------------------------

   SUBROUTINE  Sort(x, Size)
      IMPLICIT  NONE
      INTEGER, DIMENSION(1:), INTENT(INOUT) :: x
      INTEGER, INTENT(IN)                   :: Size
      INTEGER                               :: i
      INTEGER                               :: Location

      DO i = 1, Size-1			! except for the last
         Location = FindMinimum(x, i, Size)	! find min from this to last
         CALL  Swap(x(i), x(Location))	! swap this and the minimum
      END DO
   END SUBROUTINE  Sort

END PROGRAM  Sorting

MODULE  FactorialModule
   IMPLICIT  NONE

CONTAINS
  
   INTEGER FUNCTION  Factorial(N)
      IMPLICIT  NONE

      INTEGER, INTENT(IN) :: N
      INTEGER             :: Fact, i

      Fact = 1
      DO i = 1, N
         Fact = Fact * i
      END DO
      Factorial = Fact

   END FUNCTION  Factorial

   INTEGER FUNCTION  Combinatorial(N, R)
      IMPLICIT  NONE

      INTEGER, INTENT(IN) :: N, R
      INTEGER             :: Cnr

      IF (0 <= R .AND. R <= N) THEN
         Cnr = Factorial(N) / (Factorial(R)*Factorial(N-R))
      ELSE
         Cnr = 0
      END IF
      Combinatorial = Cnr

   END FUNCTION  Combinatorial

END MODULE  FactorialModule

! ---------------------------------------------------------------
!    This program "contains" two REAL functions:
!         (1)  Cm_to_Inch() takes a real inch unit and converts
!              it to cm unit, and
!         (2)  Inch_to_cm() takes a real cm unit and converts it
!              to inch unit.
! The main program uses these functions to convert 0, 0.5, 1, 1.5,
! 2.0, 2.5, ..., 8.0, 8.5, 9.0, 9.5 and 10.0 inch (resp., cm) to
! cm (resp., inch).
! ---------------------------------------------------------------

PROGRAM  Conversion
   IMPLICIT  NONE

   INTERFACE
      REAL FUNCTION  Cm_to_Inch(cm)
         REAL, INTENT(IN) :: cm
      END FUNCTION  Cm_to_Inch

      REAL FUNCTION  Inch_to_Cm(inch)
         REAL, INTENT(IN) :: inch
      END FUNCTION  Inch_to_Cm
   END INTERFACE

   REAL, PARAMETER :: Initial = 0.0, Final = 10.0, Step = 0.5
   REAL            :: x

   x = Initial
   DO                         ! x = 0, 0.5, 1.0, ..., 9.0, 9.5, 10
      IF (x > Final)  EXIT
      WRITE(*,*)  x, 'cm = ',   Cm_to_Inch(x), 'inch and ',  &
                  x, 'inch = ', Inch_to_Cm(x), 'cm'
      x = x + Step
   END DO

END PROGRAM  Conversion

! ---------------------------------------------------------------
! REAL FUNCTION  Cm_to_Inch()
!    This function converts its real input in cm to inch.
! ---------------------------------------------------------------

REAL FUNCTION  Cm_to_Inch(cm)
   IMPLICIT  NONE

   REAL, INTENT(IN) :: cm
   REAL, PARAMETER  :: To_Inch = 0.3937   ! conversion factor

   Cm_to_Inch = To_Inch * cm
END FUNCTION  Cm_to_Inch

! ---------------------------------------------------------------
! REAL FUNCTION  Inch_to_Cm()
!    This function converts its real input in inch to cm.
! ---------------------------------------------------------------

REAL FUNCTION  Inch_to_Cm(inch)
   IMPLICIT  NONE

   REAL, INTENT(IN) :: inch
   REAL, PARAMETER  :: To_Cm = 2.54       ! conversion factor

   Inch_to_Cm = To_Cm * inch
END FUNCTION  Inch_to_Cm

! ----------------------------------------------------------------
!  This program uses DATE_AND_TIME() to retrieve the system date
!  and the system time.  Then, it converts the date and time
!  information to a readable format.  This program demonstrates
!  the use of concatenation operator // and substring
! ----------------------------------------------------------------

PROGRAM  DateTime
   IMPLICIT   NONE

   CHARACTER(LEN = 8)  :: DateINFO                 ! ccyymmdd
   CHARACTER(LEN = 4)  :: Year, Month*2, Day*2

   CHARACTER(LEN = 10) :: TimeINFO, PrettyTime*12  ! hhmmss.sss
   CHARACTER(LEN = 2)  :: Hour, Minute, Second*6

   CALL  DATE_AND_TIME(DateINFO, TimeINFO)

!  decompose DateINFO into year, month and day.
!  DateINFO has a form of ccyymmdd, where cc = century, yy = year
!  mm = month and dd = day

   Year  = DateINFO(1:4)
   Month = DateINFO(5:6)
   Day   = DateINFO(7:8)

   WRITE(*,*)  'Date information -> ', DateINFO
   WRITE(*,*)  '            Year -> ', Year
   WRITE(*,*)  '           Month -> ', Month
   WRITE(*,*)  '             Day -> ', Day

!  decompose TimeINFO into hour, minute and second.
!  TimeINFO has a form of hhmmss.sss, where h = hour, m = minute
!  and s = second

   Hour   = TimeINFO(1:2)
   Minute = TimeINFO(3:4)
   Second = TimeINFO(5:10)

   PrettyTime = Hour // ':' // Minute // ':' // Second

   WRITE(*,*)
   WRITE(*,*)  'Time Information -> ', TimeINFO
   WRITE(*,*)  '            Hour -> ', Hour
   WRITE(*,*)  '          Minite -> ', Minute
   WRITE(*,*)  '          Second -> ', Second
   WRITE(*,*)  '     Pretty Time -> ', PrettyTime

!  the substring operator can be used on the left-hand side.
 
   PrettyTime = ' '
   PrettyTime( :2) = Hour
   PrettyTime(3:3) = ':'
   PrettyTime(4:5) = Minute
   PrettyTime(6:6) = ':'
   PrettyTime(7: ) = Second

   WRITE(*,*)
   WRITE(*,*)  '     Pretty Time -> ', PrettyTime 

END PROGRAM  DateTime

! --------------------------------------------------------------------
! This program finds all prime numbers in the range of 2 and an
! input integer.
! --------------------------------------------------------------------

PROGRAM  Primes
   IMPLICIT  NONE
   
   INTEGER  :: Range, Number, Count

   Range = GetNumber()   
   Count = 1                            ! input is correct. start counting
   WRITE(*,*)                           ! since 2 is a prime
   WRITE(*,*)  'Prime number #', Count, ': ', 2
   DO Number = 3, Range, 2              ! try all odd numbers 3, 5, 7, ...
      IF (Prime(Number)) THEN
         Count = Count + 1              ! yes, this Number is a prime
         WRITE(*,*)  'Prime number #', Count, ': ', Number
      END IF
   END DO
   
   WRITE(*,*)
   WRITE(*,*)  'There are ', Count, ' primes in the range of 2 and ', Range

CONTAINS

! --------------------------------------------------------------------
! INTEGER FUNCTION  GetNumber()
!    This function does not require any formal argument.  It keeps
! asking the reader for an integer until the input value is greater
! than or equal to 2.
! --------------------------------------------------------------------

   INTEGER FUNCTION  GetNumber()
      IMPLICIT  NONE

      INTEGER :: Input

      WRITE(*,*)  'What is the range ? '
      DO                                ! keep trying to read a good input
         READ(*,*)  Input               ! ask for an input integer
         IF (Input >= 2)  EXIT          ! if it is GOOD, exit
         WRITE(*,*)  'The range value must be >= 2.  Your input = ', Input
         WRITE(*,*)  'Please try again:'     ! otherwise, bug the user
      END DO
      GetNumber = Input
   END FUNCTION  GetNumber
      
! --------------------------------------------------------------------
! LOGICAL FUNCTION  Prime()
!    This function receives an INTEGER formal argument Number.  If it
! is a prime number, .TRUE. is returned; otherwise, this function
! returns .FALSE.
! --------------------------------------------------------------------

   LOGICAL FUNCTION  Prime(Number)
      IMPLICIT  NONE

      INTEGER, INTENT(IN) :: Number 
      INTEGER             :: Divisor
   
      IF (Number < 2) THEN
         Prime = .FALSE.
      ELSE IF (Number == 2) THEN
         Prime = .TRUE.
      ELSE IF (MOD(Number,2) == 0) THEN
         Prime = .FALSE.
      ELSE
         Divisor = 3
         DO
            IF (Divisor*Divisor>Number .OR. MOD(Number,Divisor)==0)  EXIT
            Divisor = Divisor + 2
         END DO
         Prime = Divisor*Divisor > Number
      END IF
   END FUNCTION  Prime

END PROGRAM  Primes

! ----------------------------------------------------------
! This program computes the average of each student and the
! the average of the class.  The input file starts with an
! integer giving the number of classes.  For each class, the
! input starts with an integer giving the number of students
! of that class, followed that number of lines on each of 
! which there are three scores.  This program reads in the
! scores and computes their average and also the class 
! averages of each score and the grant average of the class.
! ----------------------------------------------------------

PROGRAM  ClassAverage
   IMPLICIT  NONE

   INTEGER :: NoClass              ! the no. of classes
   INTEGER :: NoStudent            ! the no. of students in each class
   INTEGER :: Class, Student       ! DO control variables
   REAL    :: Score1, Score2, Score3, Average
   REAL    :: Average1, Average2, Average3, GrantAverage

   READ(*,*)  NoClass              ! read in the # of classes
   DO Class = 1, NoClass           ! for each class, do the following
      READ(*,*)  NoStudent         !   the # of student in this class
      WRITE(*,*)
      WRITE(*,*) 'Class ', Class, ' has ', NoStudent, ' students'
      WRITE(*,*)
      Average1 = 0.0               !   initialize average variables
      Average2 = 0.0
      Average3 = 0.0
      DO Student = 1, NoStudent    !   for each student in this class
         READ(*,*)  Score1, Score2, Score3   ! read in his/her scores
         Average1 = Average1 + Score1        ! prepare for class average
         Average2 = Average2 + Score2
         Average3 = Average3 + Score3
         Average  = (Score1 + Score2 + Score3) / 3.0   ! average of this one
         WRITE(*,*)  Student, Score1, Score2, Score3, Average
      END DO
      WRITE(*,*)  '----------------------'
      Average1     = Average1 / NoStudent    ! class average of score1
      Average2     = Average2 / NoStudent    ! class average of score2
      Average3     = Average3 / NoStudent    ! class average of score3
      GrantAverage = (Average1 + Average2 + Average3) / 3.0
      WRITE(*,*) 'Class Average: ', Average1, Average2, Average3
      WRITE(*,*) 'Grant Average: ', GrantAverage
   END DO

END PROGRAM  ClassAverage

! --------------------------------------------------------------------
! Given an integer, this program determines if it is a prime number.
! This program first makes sure the input is 2.  In this case, it is
! a prime number.  Then, it checks to see the input is an even 
! number.  If the input is odd, then this program divides the input
! with 3, 5, 7, ....., until one of two conditions is met:
!    (1)  if one these odd number evenly divides the input, the
!         input is not a prime number;
!    (2)  if the divisor is greater than the square toot of the
!         input, the input is a prime.
!
! A LOGICAL function Prime() is used.  This function takes a positive
! integer and returns .TRUE. if the argument is a prime number;
! otherwise, it returns .FALSE.
! --------------------------------------------------------------------

PROGRAM  PrimeNumber
   IMPLICIT  NONE

   INTEGER  :: Number
   
   READ(*,*)  Number
   IF (Prime(Number)) THEN         ! send Number to Prime() for testing
      WRITE(*,*)  Number, ' is a prime number'
   ELSE
      WRITE(*,*)  Number, ' is not a prime number'
   END IF

CONTAINS

! --------------------------------------------------------------------
! LOGICAL FUNCTION  Prime()
!    This function receives an INTEGER formal argument Number.  If it
! is a prime number, .TRUE. is returned; otherwise, this function
! returns .FALSE.
! --------------------------------------------------------------------

   LOGICAL FUNCTION  Prime(Number)
      IMPLICIT  NONE

      INTEGER, INTENT(IN) :: Number 
      INTEGER             :: Divisor
   
      IF (Number < 2) THEN
         Prime = .FALSE.
      ELSE IF (Number == 2) THEN
         Prime = .TRUE.
      ELSE IF (MOD(Number,2) == 0) THEN
         Prime = .FALSE.
      ELSE
         Divisor = 3
         DO
            IF (Divisor*Divisor>Number .OR. MOD(Number,Divisor)==0)  EXIT
            Divisor = Divisor + 2
         END DO
         Prime = Divisor*Divisor > Number
      END IF
   END FUNCTION  Prime

END PROGRAM  PrimeNumber

PROGRAM  BlankTest
   IMPLICIT  NONE
   INTEGER           :: a, b
   REAL              :: x, y
   INTEGER           :: IO
   CHARACTER(LEN=60) :: Format
   CHARACTER(LEN=5)  :: Input

   Format = "(A5, BN, T1, I5, BZ, T1, I5, BN, T1, F5.2, BZ, T1, F5.2)"

   WRITE(*,"(1X,A)")  "Input    BN    BZ      BN      BZ"
   WRITE(*,"(1X,A)")  "-----   ---   ---   -----   -----"
   DO
      READ(*,Format, IOSTAT=IO)    Input, a, b, x, y
      IF (IO < 0) EXIT
      WRITE(*,"(1X, A, 2I6, 2F8.2)")  Input, a, b, x, y
   END DO
END PROGRAM  BlankTest

! --------------------------------------------------------------------
! Given t, the time since launch, u, the launch velocity, a, the 
! initial angle of launch (in degree), and g, the acceleration due to
! gravity, this program computes the position (x and y coordinates)
! and the velocity (magnitude and direction) of a projectile.
! --------------------------------------------------------------------

PROGRAM  Projectile
   IMPLICIT    NONE
 
   REAL, PARAMETER :: g  = 9.8          ! acceleration due to gravity
   REAL, PARAMETER :: PI = 3.1415926    ! you knew this.  didn't you

   REAL            :: Angle             ! launch angle in degree
   REAL            :: Time              ! time to flight
   REAL            :: Theta             ! direction at time in degree
   REAL            :: U                 ! launch velocity
   REAL            :: V                 ! resultant velocity
   REAL            :: Vx                ! horizontal velocity
   REAL            :: Vy                ! vertical velocity
   REAL            :: X                 ! horizontal displacement
   REAL            :: Y                 ! vertical displacement

   READ(*,*)  Angle, Time, U            
   
   Angle = Angle * PI / 180.0           ! convert to radian
   X     = U * COS(Angle) * Time
   Y     = U * SIN(Angle) * Time - g*Time*Time / 2.0
   Vx    = U * COS(Angle)
   Vy    = U * SIN(Angle) - g * Time
   V     = SQRT(Vx*Vx + Vy*Vy)
   Theta = ATAN(Vy/Vx) * 180.0 / PI

   WRITE(*,*)  'Horizontal displacement : ', X
   WRITE(*,*)  'Vertical displacement   : ', Y
   WRITE(*,*)  'Resultant velocity      : ', V
   WRITE(*,*)  'Direction (in degree)   : ', Theta

END PROGRAM  Projectile

! ---------------------------------------------------
!   Solve  Ax^2 + Bx + C = 0 given B*B-4*A*C >= 0   
!   Now, we are able to detect complex roots.
! ---------------------------------------------------
 
PROGRAM  QuadraticEquation
   IMPLICIT  NONE

   REAL  :: a, b, c
   REAL  :: d
   REAL  :: root1, root2
   
!  read in the coefficients a, b and c

   READ(*,*)  a, b, c
   WRITE(*,*) 'a = ', a
   WRITE(*,*) 'b = ', b
   WRITE(*,*) 'c = ', c
   WRITE(*,*)

!  compute the square root of discriminant d

   d = b*b - 4.0*a*c
   IF (d >= 0.0) THEN              ! is it solvable?
      d     = SQRT(d)
      root1 = (-b + d)/(2.0*a)     ! first root
      root2 = (-b - d)/(2.0*a)     ! second root
      WRITE(*,*)  'Roots are ', root1, ' and ', root2
   ELSE                            ! complex roots
      WRITE(*,*)  'There is no real roots!'
      WRITE(*,*)  'Discriminant = ', d
   END IF

END PROGRAM  QuadraticEquation

PROGRAM  Smoothing
   IMPLICIT  NONE
   INTEGER, PARAMETER           :: MAX_SIZE = 20
   REAL, DIMENSION(1:MAX_SIZE)  :: x, y
   INTEGER                      :: Number
   INTEGER                      :: i
   CHARACTER(LEN=*), PARAMETER  :: TitleHeading  = "T14,A/T14,A/T14,A//T2,A,T28,A/T2,A,T28,A/"
   CHARACTER(LEN=*), PARAMETER  :: NA_Line       = "T2,I3,F10.2,A10,I6,2F10.2/"
   CHARACTER(LEN=*), PARAMETER  :: Data_Line     = "(1X,I3,2F10.2,I6,2F10.2)"
   CHARACTER(LEN=100)           :: Format

   READ(*,"(I5)")  Number
   READ(*,"(5F10.0)")  (x(i), i=1, Number)
   DO i = 1, Number-1
      y(i) = (x(i) + x(i+1)) / 2.0
   END DO

   Format = "(" // TitleHeading // NA_Line // Data_Line // ")"
   WRITE(*,Format)  "**************************",             &
                    "*  Data Smoothing Table  *",             &
                    "**************************",             &
                    (" No       x         y    ", i = 1, 2),  &
                    ("---  --------  --------  ", i = 1, 2),  &
                    1, x(1), "NA", 2, x(2), y(1),             &
                    (i, x(i), y(i-1), i = 3, Number)
END PROGRAM  Smoothing

! ---------------------------------------------------------
! This program computes exp(x) for an input x using the 
! infinite series of exp(x).  This program adds the 
! terms together until a term is less than a specified
! tolerance value.  Thus, two values are required:
! the value for x and a tolerance value.  In this program,
! he tolerance value is set to 0.00001 using PARAMETER.
! ---------------------------------------------------------

PROGRAM  Exponential
   IMPLICIT  NONE

   INTEGER         :: Count             ! # of terms used
   REAL            :: Term              ! a term
   REAL            :: Sum               ! the sum of series
   REAL            :: X                 ! the input x
   REAL, PARAMETER :: Tolerance = 0.00001    ! tolerance

   READ(*,*)  X                         ! read in x
   Count = 1                            ! the first term is 1 and counted
   Sum   = 1.0                          ! thus, the sum starts with 1
   Term  = X                            ! the second term is x
   DO                                   ! for each term
      IF (ABS(Term) < Tolerance)  EXIT  !    if too small, exit
      Sum   = Sum + Term                !    otherwise, add to sum
      Count = Count + 1                 !    count indicates the next term
      Term  = Term * (X / Count)        !    compute the value of next term
   END DO

   WRITE(*,*)  'After ', Count, ' iterations:'
   WRITE(*,*)  '  Exp(', X, ') = ', Sum
   WRITE(*,*)  '  From EXP()   = ', EXP(X)
   WRITE(*,*)  '  Abs(Error)   = ', ABS(Sum - EXP(X))

END PROGRAM  Exponential

PROGRAM  SignControl
   IMPLICIT  NONE
   INTEGER   :: i
   REAL      :: x
   CHARACTER(LEN=*), PARAMETER :: Format  = "(1X,SS,I5,SP,I5,SS,F6.1,SP,F6.1)"
   CHARACTER(LEN=*), PARAMETER :: Heading = "   SS   SP    SS    SP"

   WRITE(*,"(1X,A)") Heading
   DO i = -5, 5
      x = REAL(i)
      WRITE(*,Format)  i, i, x, x
   END DO
END PROGRAM  SignControl

PROGRAM  Decoding
   IMPLICIT  NONE
   CHARACTER(LEN=2) :: SN_1, SN_2, SN_3*3
   CHARACTER(LEN=3) :: Phone_1, Phone_2*4
   CHARACTER(LEN=3) :: Filler_1, Filler_2
   INTEGER          :: Amount
   INTEGER          :: Number
   INTEGER          :: Status
   LOGICAL          :: Problem

   WRITE(*,"(A,A)")  " ", "      Sales Amount Table"
   WRITE(*,"(A,A)")  " ", "      =================="
   WRITE(*,*)
   WRITE(*,"(A, A)")  " ", "Sales No.   Phone No.   Amount"
   WRITE(*,"(A, A)")  " ", "---------   ---------   ------"
   Problem = .FALSE.
   Number = 0
   DO
      READ(*,"(7A,I5)", IOSTAT=Status)  SN_1, SN_2, SN_3, Filler_1,  &
                                        Phone_1, Phone_2, Filler_2, Amount
      IF (Status > 0) THEN
         WRITE(*,*)  "Something wrong in your input data"
         Problem = .TRUE.
         EXIT
      ELSE IF (Status < 0) THEN
         EXIT
      ELSE
         WRITE(*,"(10A,I10)")  &
            " ", SN_1, "-", SN_2, "-", SN_3, Filler_1, &
                 Phone_1, "-", Phone_2, Amount
         Number = Number + 1
      END IF
   END DO
   IF (.NOT. Problem) THEN
      WRITE(*,*)
      WRITE(*,"(A,A,I3,A)")  " ", "Total", Number, " person(s) processed."
   END IF
END PROGRAM  Decoding

! --------------------------------------------------------------
! This program computes exp(x) for a range of x.  The range
! is in the form of beginning value, final value and step size.
! For each value in this range, the infinite series of exp(x)
! is used to compute exp(x) up to a tolerance of 0.00001.
! This program display the value of x, the exp(x) from infinite
! series, the exp(x) from Fortran's intrinsic function exp(x),
! the absolute error, and the relative error.
! --------------------------------------------------------------

PROGRAM  Exponential
   IMPLICIT  NONE

   INTEGER         :: Count             ! term count
   REAL            :: Term              ! a term
   REAL            :: Sum               ! the sum of series
   REAL            :: X                 ! running value
   REAL            :: ExpX              ! EXP(X)
   REAL            :: Begin, End, Step  ! control values
   REAL, PARAMETER :: Tolerance = 0.00001    ! tolerance

   WRITE(*,*)  'Initial, Final and Step please --> '
   READ(*,*)   Begin, End, Step

   X = Begin                            ! X starts with the beginning value
   DO
      IF (X > End)  EXIT                ! if X is > the final value, EXIT
      Count = 1                         ! the first term is 1 and counted
      Sum   = 1.0                       ! thus, the sum starts with 1
      Term  = X                         ! the second term is x
      ExpX  = EXP(X)                    ! the exp(x) from Fortran's EXP()
      DO                                ! for each term
         IF (ABS(Term) < Tolerance)  EXIT ! if too small, exit
         Sum   = Sum + Term             !   otherwise, add to sum
         Count = Count + 1              !   count indicates the next term
         Term  = Term * (X / Count)     !   compute the value of next term
      END DO

      WRITE(*,*)  X, Sum, ExpX, ABS(Sum-ExpX), ABS((Sum-ExpX)/ExpX)

      X = X + Step
   END DO

END PROGRAM  Exponential

PROGRAM  Multiplication_Table
   IMPLICIT  NONE
   INTEGER, PARAMETER :: MAX = 9
   INTEGER            :: i, j
   CHARACTER(LEN=80)  :: FORMAT

   FORMAT = "(9(2X, I1, A, I1, A, I2))"
   WRITE(*,FORMAT) ((i, '*', j, '=', i*j, j = 1, MAX), i = 1, MAX)
END PROGRAM  Multiplication_Table

PROGRAM  Smoothing
   IMPLICIT  NONE
   INTEGER, PARAMETER           :: MAX_SIZE = 20
   REAL, DIMENSION(1:MAX_SIZE)  :: x, y
   INTEGER                      :: Number
   INTEGER                      :: i
   CHARACTER(LEN=10)            :: TitleFormat   = "(T14,A)"
   CHARACTER(LEN=20)            :: HeadingFormat = "(T2,A,T28,A)"
   CHARACTER(LEN=50)            :: NA_Line       = "(T2,I3,F10.2,A10,I6,2F10.2)"
   CHARACTER(LEN=50)            :: Data_Line     = "(1X,I3,2F10.2,I6,2F10.2)"
   READ(*,"(I5)")  Number
   READ(*,"(5F10.0)")  (x(i), i=1, Number)
   DO i = 1, Number-1
      y(i) = (x(i) + x(i+1)) / 2.0
   END DO
   WRITE(*,TitleFormat)   "**************************"
   WRITE(*,TitleFormat)   "*  Data Smoothing Table  *"
   WRITE(*,TitleFormat)   "**************************"
   WRITE(*,*)
   WRITE(*,HeadingFormat)  (" No       x         y    ", i = 1, 2)
   WRITE(*,HeadingFormat)  ("---  --------  --------  ", i = 1, 2)
   WRITE(*,NA_Line)    1, x(1), "NA", 2, x(2), y(1)
   WRITE(*,Data_Line)  (i, x(i), y(i-1), i = 3, Number)
END PROGRAM  Smoothing

! ---------------------------------------------------------------
! This program determines all prime factors of an n integer >= 2.
! It first removes all factors of 2.  Then, removes all factors
! of 3, 5, 7, and so on.  All factors must be prime numbers since
! when a factor is tried all of whose non-prime factors have 
! already been removed.
! ---------------------------------------------------------------

PROGRAM  Factorize
   IMPLICIT  NONE

   INTEGER  :: Input
   INTEGER  :: Divisor
   INTEGER  :: Count

   WRITE(*,*)  'This program factorizes any integer >= 2 --> '
   READ(*,*)   Input

   Count = 0
   DO                         ! here, we try to remove all factors of 2
      IF (MOD(Input,2) /= 0 .OR. Input == 1)  EXIT
      Count = Count + 1       ! increase count
      WRITE(*,*)  'Factor # ', Count, ': ', 2
      Input = Input / 2       ! remove this factor from Input
   END DO

   Divisor = 3                ! now we only worry about odd factors
   DO                         ! 3, 5, 7, .... will be tried
      IF (Divisor > Input) EXIT    ! if a factor is too large, exit and done
      DO                      ! try this factor repeatedly
         IF (MOD(Input,Divisor) /= 0 .OR. Input == 1)  EXIT
         Count = Count + 1
         WRITE(*,*)  'Factor # ', Count, ': ', Divisor
         Input = Input / Divisor   ! remove this factor from Input
      END DO
      Divisor = Divisor + 2   ! move to next odd number
   END DO

END PROGRAM  Factorize

! ----------------------------------------------------------
! This program solve the following puzzle:
!                RED
!            x   FOR
!            -------
!             DANGER
! where each distinct letter represents a different digit.
! Moreover, R, F and D cannot be zero.
! ----------------------------------------------------------

PROGRAM  Puzzle
   IMPLICIT  NONE

   INTEGER :: R, E, D, F, O, A, N, G    ! the digits
   INTEGER :: RED, FOR, DANGER          ! the constructed values
   INTEGER :: Count                     ! solutions count

   WRITE(*,*)  'This program solves the following puzzle:'
   WRITE(*,*)
   WRITE(*,*)  '    RED'
   WRITE(*,*)  'x   FOR'
   WRITE(*,*)  '-------'
   WRITE(*,*)  ' DANGER'
   WRITE(*,*)

   Count = 0
   DO R = 1, 9
     DO E = 0, 9
       IF (E == R) CYCLE
       DO D = 1, 9
         IF (D == R .OR. D == E) CYCLE
         DO F = 1, 9
           IF (F == R .OR. F == E .OR. F == D) CYCLE
           DO O = 0, 9
             IF (O == R .OR. O == E .OR. O == D .OR.            &
                 O == F)  CYCLE
             DO A = 0, 9
               IF (A == R .OR. A == E .OR. A == D .OR.          &
                   A == F .OR. A == O)  CYCLE
               DO N = 0, 9
                 IF (N == R .OR. N == E .OR. N == D .OR.        &
                     N == F .OR. N == O .OR. N == A)  CYCLE
                 DO G = 0, 9
                   IF (G == R .OR. G == E .OR. G == D .OR.      &
                       G == F .OR. G == O .OR. G == A .OR.      &
                       G == N)  CYCLE
                   RED    = R*100 + E*10 + D
                   FOR    = F*100 + O*10 + R
                   DANGER = D*100000 + A*10000 + N*1000 + G*100 + E*10 + R
                   IF (RED * FOR == DANGER) THEN
                      Count = Count + 1
                      WRITE(*,*) 'Solution ', Count, ':'
                      WRITE(*,*) '     RED = ', RED
                      WRITE(*,*) '     FOR = ', FOR
                      WRITE(*,*) '  DANGER = ', DANGER
                      WRITE(*,*)
                   END IF
                 END DO
               END DO
             END DO
           END DO
         END DO
       END DO
     END DO
   END DO

END PROGRAM  Puzzle

! ----------------------------------------------------------
! This program reads a series of input data values and 
! computes their arithmetic, geometric and harmonic means.
! Since geometric mean requires taking n-th root, all input
! data item must be all positive (a special requirement of
! this program , although it is not absolutely necessary).
! If an input item is not positive, it should be ignored.
! Since some data items may be ignored, this program also
! checks to see if no data items remain!
! ----------------------------------------------------------

PROGRAM   ComputingMeans
   IMPLICIT  NONE

   REAL    :: X
   REAL    :: Sum, Product, InverseSum
   REAL    :: Arithmetic, Geometric, Harmonic
   INTEGER :: Count, TotalNumber, TotalValid

   Sum        = 0.0                     ! for the sum
   Product    = 1.0                     ! for the product
   InverseSum = 0.0                     ! for the sum of 1/x
   TotalValid = 0                       ! # of valid items

   READ(*,*)  TotalNumber               ! read in # of items
   DO Count = 1, TotalNumber            ! for each item ...
      READ(*,*)  X                      ! read it in
      WRITE(*,*) 'Input item ', Count, ' --> ', X
      IF (X <= 0.0) THEN                ! if it is non-positive
         WRITE(*,*) 'Input <= 0.  Ignored'   ! ignore it
      ELSE                              ! otherwise,
         TotalValid = TotalValid + 1    ! count it in
         Sum        = Sum + X           ! compute the sum,
         Product    = Product * X       ! the product
         InverseSum = InverseSum + 1.0/X     ! and the sum of 1/x
      END IF
   END DO

   IF (TotalValid > 0) THEN             ! are there valid items?
      Arithmetic = Sum / TotalValid     ! yes, compute means
      Geometric  = Product**(1.0/TotalValid)
      Harmonic   = TotalValid / InverseSum

      WRITE(*,*)  'No. of valid items --> ', TotalValid
      WRITE(*,*)  'Arithmetic mean    --> ', Arithmetic
      WRITE(*,*)  'Geometric mean     --> ', Geometric
      WRITE(*,*)  'Harmonic mean      --> ', Harmonic
   ELSE                                 ! no, display a message
      WRITE(*,*)  'ERROR: none of the input is positive'
   END IF

END PROGRAM  ComputingMeans

! --------------------------------------------------------------------
! PROGRAM  HeronFormula:
!    This program contains one subroutine that takes three REAL values
! and computes the area of the triangle bounded by the input values.
! --------------------------------------------------------------------

PROGRAM  HeronFormula
   IMPLICIT  NONE

   REAL    :: Side1, Side2, Side3       ! input values
   REAL    :: Answer                    ! will hold the area
   LOGICAL :: ErrorStatus               ! return status

   READ(*,*)  Side1, Side2, Side3
   CALL  TriangleArea(Side1, Side2, Side3, Answer, ErrorStatus)
   IF (ErrorStatus) THEN                ! if error occurs in subroutine
      WRITE(*,*)  "ERROR: not a triangle"    ! display a message
   ELSE                                 ! otherwise, display the area
      WRITE(*,*)  "The triangle area is ", Answer
   END IF
   
CONTAINS

! --------------------------------------------------------------------
! SUBROUTINE  TriangleArea():
!    This subroutine takes three REAL values as the sides of a 
! triangle.  Then, it tests to see if these values do form a triangle.
! If they do, the area of the triangle is computed and returned with
! formal argument Area and .FALSE. is returned with Error.  Otherwise,
! the area is set to 0.0 and .TRUE. is returned with Error.
! --------------------------------------------------------------------

   SUBROUTINE  TriangleArea(a, b, c, Area, Error)
      IMPLICIT  NONE

      REAL, INTENT(IN)     :: a, b, c   ! input sides
      REAL, INTENT(OUT)    :: Area      ! computed area
      LOGICAL, INTENT(OUT) :: Error     ! error indicator

      REAL                 :: s
      LOGICAL              :: Test1, Test2

      Test1 = (a > 0) .AND. (b > 0) .AND. (c > 0)
      Test2 = (a+b > c) .AND. (a+c > b) .AND. (b+c > a)
      IF (Test1 .AND. Test2) THEN       ! a triangle?
         Error = .FALSE.                ! yes.  no error
         s     = (a + b + c)/2.0        ! compute area
         Area  = SQRT(s*(s-a)*(s-b)*(s-c))
      ELSE
         Error = .TRUE.                 ! not a triangle
         Area  = 0.0                    ! set area to zero
      END IF
   END SUBROUTINE  TriangleArea

END PROGRAM  HeronFormula

PROGRAM  Logical_Input
   IMPLICIT  NONE
   LOGICAL           :: P, Q
   INTEGER           :: i, Number

   WRITE(*,"(A, A)")  " ", "  Truth Table"
   WRITE(*,"(A, A)")  " ", "  -----------"
   WRITE(*,*)
   WRITE(*,"(A,A)")   " ", "    P      Q    P | Q  P & Q  P ^ Q  P = Q"
   WRITE(*,"(A,6A)")  " ", ("  -----", i = 1, 6)
   READ(*,"(I5)")  Number
   DO i = 1, Number
      READ(*,"(2L10)")  P, Q
      WRITE(*,"(A, 6L7)")  " ", P, Q, &
                            P .OR. Q, P .AND. Q, P .NEQV. Q, P .EQV. Q
   END DO
END PROGRAM  Logical_Input

! --------------------------------------------------------------------
!    This program solves equations with the Bisection Method.  Given
! a function f(x) = 0.  The bisection method starts with two values,
! a and b such that f(a) and f(b) have opposite signs.  That is,
! f(a)*f(b) < 0.  Then, it is guaranteed that f(x)=0 has a root in
! the range of a and b.  This program reads in a and b (Left and Right
! in this program) and find the root in [a,b].
!    In the following, function f() is REAL FUNCTION Funct() and
! solve() is the function for solving the equation.
! --------------------------------------------------------------------

PROGRAM  Bisection
   IMPLICIT  NONE

   REAL, PARAMETER :: Tolerance = 0.00001
   REAL            :: Left,  fLeft
   REAL            :: Right, fRight
   REAL            :: Root
   
   WRITE(*,*)  'This program can solves equation F(x) = 0'
   WRITE(*,*)  'Please enter two values Left and Right such that '
   WRITE(*,*)  'F(Left) and F(Right) have opposite signs.'
   WRITE(*,*)
   WRITE(*,*)  'Left and Right please --> '
   READ(*,*)   Left, Right              ! read in Left and Right

   fLeft  = Funct(Left)                 ! compute their function values
   fRight = Funct(Right)
   WRITE(*,*)
   WRITE(*,*)  'Chwith = ', Left, '    f(Chwith) = ', fLeft             !//{cym} Welsh
   WRITE(*,*)  'Linke = ', Left, '    f(Linke) = ', fLeft               !//{deu} German
   WRITE(*,*)  'Left = ', Left, '    f(Left) = ', fLeft                 !//{eng} English
   WRITE(*,*)  'Sinistra = ', Left, '    f(Sinistra) = ', fLeft         !//{ina,ita} Interlingua,Italian
   WRITE(*,*)  'Sinister = ', Left, '    f(Sinister) = ', fLeft         !//{lat} Latin
   WRITE(*,*)  'Esquerda = ', Left, '    f(Esquerda) = ', fLeft         !//{por} Portuguese
   WRITE(*,*)  'Izquierda = ', Left, '    f(Izquierda) = ', fLeft       !//{spa} Spanish
   WRITE(*,*)  'De = ', Right, '   f(De) = ', fRight                    !//{cym} Welsh
   WRITE(*,*)  'Rechte = ', Right, '   f(Rechte) = ', fRight            !//{deu} German
   WRITE(*,*)  'Right = ', Right, '   f(Right) = ', fRight              !//{eng} English
   WRITE(*,*)  'Dextra = ', Right, '   f(Dextra) = ', fRight            !//{ina} Interlingua
   WRITE(*,*)  'Destra = ', Right, '   f(Destra) = ', fRight            !//{ita} Italian
   WRITE(*,*)  'Dexter = ', Right, '   f(Dexter) = ', fRight            !//{lat} Latin
   WRITE(*,*)  'Dereita = ', Right, '   f(Dereita) = ', fRight          !//{por} Portuguese
   WRITE(*,*)  'Derecha = ', Right, '   f(Derecha) = ', fRight          !//{spa} Spanish
   WRITE(*,*)
   IF (fLeft*fRight > 0.0)  THEN
      WRITE(*,*)  '*** ERROR: f(Left)*f(Right) must be negative ***'
   ELSE
      Root = Solve(Left, Right, Tolerance)
      WRITE(*,*)  'A root is ', Root
   END IF

CONTAINS

! --------------------------------------------------------------------
! REAL FUNCTION  Funct()
!    This is for function f(x).  It takes a REAL formal argument and
! returns the value of f() at x.  The following is sample function
! with a root in the range of -10.0 and 0.0.  You can change the
! expression with your own function.
! --------------------------------------------------------------------
   
   REAL FUNCTION  Funct(x)
      IMPLICIT  NONE
      REAL, INTENT(IN) :: x
      REAL, PARAMETER  :: PI = 3.1415926
      REAL, PARAMETER  :: a  = 0.8475

      Funct = SQRT(PI/2.0)*EXP(a*x) + x/(a*a + x*x)
            
   END FUNCTION  Funct

! --------------------------------------------------------------------
! REAL FUNCTION  Solve()
!    This function takes Left - the left end, Right - the right end,
! and Tolerance - a tolerance value such that f(Left)*f(Right) < 0
! and find a root in the range of Left and Right.
!    This function works as follows.  Because of INTENT(IN), this
! function cannot change the values of Left and Right and therefore
! the values of Left and Right are saved to a and b.
!    Then, the middle point c=(a+b)/2 and its function value f(c)
! is computed.  If f(a)*f(c) < 0, then a root is in [a,c]; otherwise, 
! a root is in [c,b].  In the former case, replacing b and f(b) with
! c and f(c), we still maintain that a root in [a,b].  In the latter,
! replacing a and f(a) with c and f(c) will keep a root in [a,b].
! This process will continue until |f(c)| is less than Tolerance and
! hence c can be considered as a root.
! --------------------------------------------------------------------
 
   REAL FUNCTION  Solve(Left, Right, Tolerance)
      IMPLICIT  NONE
      REAL, INTENT(IN) :: Left, Right, Tolerance
      REAL             :: a, Fa, b, Fb, c, Fc
      
      a = Left                          ! save Left and Right
      b = Right
      
      Fa = Funct(a)                     ! compute the function values
      Fb = Funct(b)
      IF (ABS(Fa) < Tolerance) THEN     ! if f(a) is already small
         Solve = a                      ! then a is a root
      ELSE IF (ABS(Fb) < Tolerance) THEN     ! is f(b) is small
         Solve = b                      ! then b is a root
      ELSE                              ! otherwise,
         DO                             ! iterate ....
            c  = (a + b)/2.0            !   compute the middle point
            Fc = Funct(c)               !   and its function value
            IF (ABS(Fc) < Tolerance) THEN    ! is it very small?
               Solve = c                ! yes, c is a root
               EXIT
            ELSE IF (Fa*Fc < 0.0) THEN  ! do f(a)*f(c) < 0 ?
               b  = c                   ! replace b with c
               Fb = Fc                  ! and f(b) with f(c)
            ELSE                        ! then f(c)*f(b) < 0 holds
               a  = c                   ! replace a with c
               Fa = Fc                  ! and f(a) with f(c)
            END IF                      
         END DO                         ! go back and do it again
      END IF
   END FUNCTION  Solve
   
END PROGRAM  Bisection

            

! ------------------------------------------------------------
!     This program illustrates the following points:
!     (1)  The exponential trap:
!          That is, A**B**C is equal to A**(B**C) rather
!          than (A**B)**C.
!     (2)  The integer division trap:
!          That is, 4/6 is ZERO in Fortran rather than
!          a real number 0.666666
!          Function REAL() is used to illustrate the
!          differences.
!     (3)  The string truncation trap:
!          What if the length assigned to a CHARACTER
!          is shorter than the length of the string you
!          expect the identifier to have?  The third part
!          shows you the effect.
! ------------------------------------------------------------

PROGRAM      Fortran_Traps
   IMPLICIT     NONE

   INTEGER, PARAMETER          :: A = 2, B = 2, H = 3
   INTEGER, PARAMETER          :: O = 4, P = 6
   CHARACTER(LEN=5), PARAMETER :: M = 'Smith', N = 'TEXAS'
   CHARACTER(LEN=4), PARAMETER :: X = 'Smith'
   CHARACTER(LEN=6), PARAMETER :: Y = 'TEXAS'

!  The exponential trap

   WRITE(*,*)   "First, the exponential trap:"
   WRITE(*,*)   A, ' ** ', B, ' ** ', H, ' = ', A**B**H
   WRITE(*,*)   '( ', A, ' ** ', B, ' ) **', H, ' = ', (A**B)**H
   WRITE(*,*)   A, ' ** ( ', B, ' ** ', H, ' ) = ', A**(B**H)
   WRITE(*,*)

!  The integer division trap.  Intrinsic function REAL() converts
!  an integer to a real number

   WRITE(*,*)   "Second, the integer division trap:"
   WRITE(*,*)
   WRITE(*,*)   O, ' / ', P, ' = ', O/P
   WRITE(*,*)   'REAL( ', O, ' ) / ', P, ' = ', REAL(O)/P
   WRITE(*,*)   O, ' / REAL( ', P, ' ) = ', O/REAL(P)
   WRITE(*,*)

!  The string truncation trap

   WRITE(*,*)   "Third, the string truncation trap:"
   WRITE(*,*)   'IS ', M, ' STILL IN ', N, '?'
   WRITE(*,*)   'IS ', X, ' STILL IN ', Y, '?'

END PROGRAM  Fortran_Traps

! --------------------------------------------------------------------
! PROGRAM  TableLookUp
!    Given an array and a input value, this program can determine if 
! the value if in the table.  If it is, the array location where the 
! value is stored is returned.
! --------------------------------------------------------------------

PROGRAM  TableLookUp
   IMPLICIT  NONE
   INTEGER, PARAMETER              :: TableSize = 100
   INTEGER, DIMENSION(1:TableSize) :: Table
   INTEGER                         :: ActualSize
   INTEGER                         :: Key
   INTEGER                         :: Location
   INTEGER                         :: i
   INTEGER                         :: end_of_input

   READ(*,*)  ActualSize                ! read in the actual size and table
   READ(*,*)  (Table(i), i = 1, ActualSize)
   WRITE(*,*) "Input Table:"
   WRITE(*,*) (Table(i), i = 1, ActualSize)
   WRITE(*,*)
   DO                                   ! keep reading in a key value
      WRITE(*,*)  "A search key please --> "
      READ(*,*,IOSTAT=end_of_input)  Key
      IF (end_of_input < 0)  EXIT       ! EXIT of end-of-file reached
      Location = LookUp(Table, ActualSize, Key)   ! do a table look up
      IF (Location > 0) THEN            ! display the search result
         WRITE(*,*)  "Key value ", Key, " appears in location ", Location
      ELSE
         WRITE(*,*)  "Key value ", Key, " is not found"
      END IF
   END DO
   WRITE(*,*)
   WRITE(*,*) "Table lookup operation completes"

CONTAINS

! --------------------------------------------------------------------
! INTEGER FUNCTION  LookUp():
!    Given an array x() and a key value Data, this function determines
! if Data is a member of x().  If it is, the index where Data can be 
! found is returned; otherwise, it returns 0.
! --------------------------------------------------------------------

   INTEGER FUNCTION  LookUp(x, Size, Data)
      IMPLICIT  NONE
      INTEGER, DIMENSION(1:), INTENT(IN) :: x
      INTEGER, INTENT(IN)                :: Size
      INTEGER, INTENT(IN)                :: Data
      INTEGER                            :: i

      LookUp = 0                        ! assume not found
      DO i = 1, Size                    ! check each array element
         IF (x(i) == Data) THEN         !   is it equal to Data?
            LookUp = i                  !   YES, found.  Record location
            EXIT                        !   and bail out
         END IF
      END DO
   END FUNCTION  LookUp

END PROGRAM  TableLookUp
